Package: ExiMiR
Type: Package
Title: R functions for the normalization of Exiqon miRNA array data
Version: 2.55.0
Date: 2012-11-06
Author: Sylvain Gubian <DL.RSupport@pmi.com>, Alain Sewer
        <DL.RSupport@pmi.com>, PMP SA
Maintainer: Sylvain Gubian <DL.RSupport@pmi.com>
Depends: R (>= 2.10), Biobase (>= 2.5.5), affy (>= 1.26.1), limma
Imports: affyio(>= 1.13.3), Biobase(>= 2.5.5), preprocessCore(>=
        1.10.0)
Suggests: mirna10cdf
Description: This package contains functions for reading raw data in
        ImaGene TXT format obtained from Exiqon miRCURY LNA arrays,
        annotating them with appropriate GAL files, and normalizing
        them using a spike-in probe-based method. Other platforms and
        data formats are also supported.
License: GPL-2
Collate: make.gal.env.R read.exi.R createAB.R NormiR.R NormiR.methods.R
LazyLoad: yes
biocViews: Microarray, OneChannel, TwoChannel, Preprocessing,
        GeneExpression, Transcription
git_url: https://git.bioconductor.org/packages/ExiMiR
git_branch: devel
git_last_commit: 271382b
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 22:35:41 UTC; biocbuild

# File: NormiR.methods.R
# 
# Author: sylvain.gubian@pmi.com

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.

#########################################################################################

NormiR.bgcorrect.methods <- function(object) {
	if (class(object)!="AffyBatch") {
		stop(paste("Object of class", class(object),"not supported"))
	}
	if(!is.from.createAB(object)) {
		return(bgcorrect.methods())
	} else {
		if (is.dual(object)) {
			return(c("none", "subtract", "half","minimum", "movingmin", "edwards", "normexp"))
		} else {
			return(bgcorrect.methods())
		}
	}
}

NormiR.normalize.methods <- function(object) {
	if (class(object)!="AffyBatch") {
		stop(paste("Object of class", class(object),"not supported"))
	}
	return(c("spikein","quantile","median","mean","none"))
}

NormiR.pmcorrect.methods <- function(object) {
	if (class(object)!="AffyBatch") {
		stop(paste("Object of class", class(object),"not supported"))
	}
	if (!is.from.createAB(object)) {
		if(all(is.na(mm(object)))) {
			return("pmonly")
		} else {
			return(pmcorrect.methods())
		}
	} else {
		warning("pm correction is not applicable for this data type")
		return(NULL)
	}
}

NormiR.summary.methods <- function() {
	return(generateExprSet.methods())
}

NormiR.spikein.args <- function() {
	return(c(	"min.corr",
				"loess.span",
				"extrap.points",
				"extrap.method",
				"force.zero",
				"cover.ext",
				"cover.int",
				"max.log2span",
				"figures.show",
				"figures.output"))
}

# File: make.gal.env.R
# 
# Author: Sylvain Gubian, Alain Sewer, PMP SA

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.

#########################################################################################

make.gal.env <- function(galname=NULL, filename=NULL, gal.path=getwd(), verbose=FALSE) {
	if (is.null(galname)) {
		stop("galname argument has to be provided")
	}
	if (isTRUE(verbose)) {
		cat("Reading GAL file...\n")
	}
	if(is.null(filename)) {
		if (verbose) {
			cat(paste("No filename provided, looking for GAL file in folder:", gal.path, "...\n"))
		}
		if(is.null(gal.path)) gal.path <- getwd()
		filename <- dir(path=gal.path,pattern="\\.gal$")
		nfiles <- length(filename)
		if(nfiles == 0) stop("Cannot find GAL file.")
		if (nfiles == 1) {
			if (verbose) {
				cat(paste('Using GAL file:', filename[1],"\n"))
			}
		}
		if(nfiles > 1) {
			stop("Several GAL files detected, use 'filename' argument to specify which one to use.")
		}
	}
	if(is.null(gal.path)) {
		if (verbose) {
			warning("gal.path is null, using working directory...")
		}
		gal.path <- getwd()
	}
	path <- file.path(path.expand(gal.path),filename)
	if (!file.exists(path)) {
		stop("Can not open GAL file")
	}
	
	df <- readGAL(galfile=filename, path=gal.path)
	printer <-  getLayout(df)
	IDS <- df$ID
	GNAMES <- df$Name
	BLOCKS <- df$Block
	COLS <- df$Column
	ROWS <- df$Row
	
	perm.list <- list()
	perm.list$block.row <- printer$ngrid.r
	perm.list$block.col <- printer$ngrid.c
	bi <- (BLOCKS-1) %/% perm.list$block.col  + 1
	bj <- (BLOCKS-1) %% perm.list$block.col + 1
	NROWS <- printer$nspot.r
	NCOLS <- printer$nspot.c
	perm.list$rindex <- ROWS + (bi-1) * NROWS
	perm.list$cindex <- COLS + (bj-1) * NCOLS
	perm.list$vect <- vector()
	perm.list$vect <- perm.list$rindex + (perm.list$cindex-1) * max(perm.list$rindex)
	
	annotation.struct <- list(IDS=IDS, GNAMES=GNAMES, BLOCKS=BLOCKS, COLS=COLS, ROWS=ROWS, NROWS=NROWS, NCOLS=NCOLS)
	if (isTRUE(verbose)) {
		cat(paste("Creating environment using name:", galname,"\n"))
	}	
	create.gal.env(galname = galname, struct=annotation.struct, perm=perm.list)
	
	galfile.env <- new.env(hash=TRUE, parent=emptyenv())
	galfile.env.name <- paste(galname,".envfile", sep="")
	galfile.list <- list(path=gal.path, filename=filename)
	assign("galfile.info", galfile.list, galfile.env)
	assign(galfile.env.name, galfile.env, envir=globalenv())
}

create.gal.env <- function(galname, struct, perm) {
	# Create galenv for the affybatch
	galenv <- new.env(hash=TRUE, parent=emptyenv())
	map <- list()
	#map.bg <- list()
	ulist=which(!duplicated(struct$IDS))
	nams = as.character(struct$GNAMES[ulist])
	ids = struct$IDS[ulist]
	
	for(i in 1:length(ulist)) {
		values <- list()
		#values.bg <- list()
		matches <- which(struct$IDS == ids[i])
		if (nams[i] == "") {
			nams[i] <- paste("HIDDEN_", ids[i], sep='')
		} else if (nchar(nams[i]) > 255) {
			nams[i] <- substr(nams[i], 1, 255)
		}
		n <- length(matches)
		blocks.match <- struct$BLOCKS[matches]
		columns.match <- struct$COLS[matches]
		rows.match <- struct$ROWS[matches]
		
		if (is.null(perm)) {
			for(j in 1:n) {
				values[j] <- bcr2i(blocks.match[j], columns.match[j], rows.match[j], struct$NCOLS, struct$NROWS) 
				#values.bg[j] <- bcr2i(blocks.match[j], columns.match[j], rows.match[j], ncol, nrow) + length(ROWS)
			}
		} else {
			for(j in 1:n) {
				values[j] <- perm$vect[bcr2i(blocks.match[j], columns.match[j], rows.match[j], struct$NCOLS, struct$NROWS)]
				#values.bg[j] <- perm.list$vect[bcr2i(blocks.match[j], columns.match[j], rows.match[j], ncol, nrow)] +length(ROWS)
			}
		}
		tmp <- as.matrix(as.integer(values))
		#tmpbg <- as.matrix(as.integer(values.bg))
		mmNA <- matrix(NA, nrow(tmp), 1)
		tmp <- cbind(tmp, mmNA)
		#tmpbg <- cbind(tmpbg,mmNA)
		colnames(tmp) <- c("pm", "mm")
		#colnames(tmpbg) <- c("pm", "mm")
		map[[i]] <- tmp
		#map.bg[[i]] <- tmpbg
	}
	
	names(map) <- nams
	#names(map.bg) <- nams
	multiassign(names(map), map, galenv)
	#multiassign(names(map.bg), map.bg, galenv.bg)
	assign(galname, galenv, envir=globalenv())
	#assign(paste(galname,".bg",sep=""),  galenv.bg, envir=globalenv())
}

i2bcr <- function(index, ncols, nrows) {
	res <- list()
	res$b <- (index-1) %/% (nrows*ncols) + 1 ;
	res$r <- (index-1-((res$b-1)*nrows*ncols)) %/% ncols + 1
	res$c <- (index-1-((res$b-1)*nrows*ncols)) %% ncols + 1
	return(res)
}

bcr2i <- function(block, col, row, ncols, nrows) {
	return((block - 1)* nrows * ncols + (row-1) * ncols + (col-1) + 1)
}

# File: NormiR.R
# 
# Author: Sylvain Gubian, Alain Sewer, PMP SA
# Aim: Set of functions for Exiqon data normalization

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.

#########################################################################################

NormiR <- function(
		abatch,
		# background correction
		bg.correct = TRUE,
		bgcorrect.method = 'auto',
		bgcorrect.param = list(),
		# normalize
		normalize = TRUE,
		normalize.method = 'spikein',
		normalize.param = list(),
		# pm correction
		pmcorrect.method = 'pmonly',
		pmcorrect.param = list(),
		# expression values
		summary.method = 'medianpolish',
		summary.param = list(),
		summary.subset = NULL,
		# misc.
		verbose = FALSE,
		...
) {
	if (is.null(summary.method)) {
		stop("Please specify a summarization method, for example: 'medianpolish'")
	}
	
	if (is.null(pmcorrect.method)) {
		if (!is.from.createAB(abatch)) {
			stop("Please specify a pmcorrect method, for example: 'pmonly'")
		}
	}
	# For backward compatibility
	#dot.args <- match.call(expand.dots=TRUE)
	dot.args <- list(...)
	if (!is.null(dot.args$background.correct)) {
		bg.correct = dot.args$background.correct
		if (bg.correct) {
			bgcorrect.method = "auto" ;
		}
	}
	if (is.null(bgcorrect.method)) {
		bgcorrect.method = "auto" ;
	}
	
	# End of backward compatibility section
	# Call background correction if asked
	if (isTRUE(bg.correct)) {
		if(isTRUE(verbose)) {
			cat("Background correction...\n")
		}
		ab.bg.corrected <- bg.correct.miR(abatch = abatch, bgcorrect.method=bgcorrect.method, bgcorrect.param=bgcorrect.param, verbose=verbose)
	} else {
		ab.bg.corrected <- abatch
	}
	if (isTRUE(normalize)) {
		if(isTRUE(verbose)) {
			cat("Normalization...\n")
		}
		ab.normalized <- norm.miR(abatch = ab.bg.corrected, normalize.method=normalize.method, normalize.param=normalize.param, verbose = verbose,...)
	} else {
		ab.normalized <- ab.bg.corrected
	}
	
	if(isTRUE(verbose)) {
		cat("Summarization...\n")
	}
	ab.summarized <- summarize.miR(abatch = ab.normalized, pmcorrect.method = pmcorrect.method, pmcorrect.param = pmcorrect.param, summary.method = summary.method, summary.param = summary.param, summary.subset = summary.subset)
	
	return(ab.summarized)
}

bg.correct.miR <- function(abatch, bgcorrect.method="auto", bgcorrect.param = list(), verbose=FALSE) {	
	if (is.from.createAB(abatch)) {
		if (is.null(bgcorrect.param$offset)) {
			bgcorrect.param$offset = 0
		}
		# Creating the limma object for backgroundCorrect function:
		if (is.dual(abatch)) {
			if (bgcorrect.method=="auto")
				bgcorrect.method="normexp"
			if (is.null(bgcorrect.param$normexp.method)) {
				bgcorrect.param$normexp.method = "saddle"
			}
			
			lim.obj <- new("RGList")
			lim.obj$G <- exprs(abatch)[,1:(ncol(exprs(abatch))/2)]
			lim.obj$R <- exprs(abatch)[,((ncol(exprs(abatch))/2)+1):(ncol(exprs(abatch)))]
			if (has.bg(abatch)) {
				lim.obj$Gb <- se.exprs(abatch)[,1:(ncol(exprs(abatch))/2)]
				lim.obj$Rb <- se.exprs(abatch)[,((ncol(exprs(abatch))/2)+1):(ncol(exprs(abatch)))]
			} else {
				lim.obj$Gb <- NULL
				lim.obj$Rb <- NULL
			}
			lim.obj$R <- backgroundCorrect.matrix(lim.obj$R, lim.obj$Rb, method = bgcorrect.method, 
					offset = bgcorrect.param$offset, normexp.method = bgcorrect.param$normexp.method, 
					verbose = verbose)
			lim.obj$G <- backgroundCorrect.matrix(lim.obj$G, lim.obj$Gb, method = bgcorrect.method, 
					offset = bgcorrect.param$offset, normexp.method = bgcorrect.param$normexp.method, 
					verbose = verbose)
			abatch.bg.corrected <- abatch
			exprs(abatch.bg.corrected) <- cbind(lim.obj$G, lim.obj$R)
			if (has.bg(abatch))
				se.exprs(abatch.bg.corrected) <- cbind(lim.obj$Gb, lim.obj$Rb)
		} else {
#			E <- exprs(abatch)[,1:(ncol(exprs(abatch)))]
#			Eb <- NULL
#			if (has.bg(abatch)) {
#				Eb <- se.exprs(abatch)[,1:(ncol(exprs(abatch)))]
#			}
#			E <-  backgroundCorrect.matrix(E=E, Eb=Eb, method=bgcorrect.method,
#					normexp.method= bgcorrect.param$normexp.method,
#					offset=bgcorrect.param$offset,
#					verbose=verbose)
#			abatch.bg.corrected <- abatch
#			exprs(abatch.bg.corrected) <- E
#			if (has.bg(abatch))
#				se.exprs(abatch.bg.corrected) <- Eb
			if (bgcorrect.method=="auto")
				bgcorrect.method="rma"
			if ((bgcorrect.method%in%bgcorrect.methods()))
				abatch.bg.corrected <- bg.correct(abatch, method=bgcorrect.method)
			else {
				stop("Background method not supported for the AffyBatch object provided")
			}
			abatch.bg.corrected <- bg.correct(abatch, method=bgcorrect.method)
		}	
	} else {
		# affy bg.correct
		if (bgcorrect.method=="auto")
			bgcorrect.method="rma"
		if ((bgcorrect.method%in%bgcorrect.methods()))
			abatch.bg.corrected <- bg.correct(abatch, method=bgcorrect.method)
		else {
			stop("Background method not supported for the AffyBatch object provided")
		}
	}
	return(abatch.bg.corrected)
}


norm.miR <- function(abatch, normalize.method ="spikein", normalize.param = list(), verbose=TRUE, ...)
{
	# For backward compatibility
	#dot.args <- match.call(expand.dots=TRUE)
	dot.args <- list(...)
	normalize.method.params <- c(
			"min.corr",
			"loess.span",
			"extrap.points",
			"extrap.method",
			"force.zero",
			"cover.ext",
			"cover.int",
			"max.log2span",
			"figures.show",
			"figures.output")
	if (!is.null(dot.args$method)) {
		normalize.method = dot.args$method;
	}
	for(param in normalize.method.params) {
		if (!is.null(unlist(as.list(dot.args[param])))) {
			normalize.param[param] = dot.args[param];
		}
	}
	if (is.null(normalize.method)) {
		normalize.method = "spikein"
	}
	
	if (normalize.method =="spikein") {
		# Check parameters
		control.params <- list(
				min.corr = 0.5,
				figures.show=TRUE,
				figures.output="display",
				loess.span=-1,
				extrap.points=2,
				extrap.method="mean",
				force.zero=FALSE,
				cover.ext=0.5,
				cover.int=1/3,
				max.log2span=1,
				probeset.list=NULL
		)
		nmsC <- names(control.params)
		control.params[(namc <- names(normalize.param))] <-  normalize.param
		if(length(noNms <- namc[!namc %in% nmsC]))
			warning("Not supported spikein normalization parameters: ", paste(noNms,collapse=", "))
		
		galenv <- getCdfInfo(abatch)
		l <- mget(ls(galenv),galenv)
		
		have.probe.control <- FALSE
		if (!is.null(normalize.param$probeset.list)) {
			if (length(normalize.param$probeset.list)==0) {
				warning("No probe names given as control, using spikes-in controls if any.")	
			}  else {
				# Check if the list matches the probes names we have
				have.probe.control <- TRUE
				#print(normalize.param$probeset.list)
				matches <- match(normalize.param$probeset.list,names(l))
				if (any(is.na(matches))) {
					if (all(is.na(matches))) {
						have.probe.control <- FALSE
						stop("No probe set names given as control match probes names in the AffyBatch object.")
					} else {
						warning("Some probe set names given as control do not match the ones in the Affybatch object.")
					}
				}
				spike.list <- matches[!is.na(matches)]
			}
		}
		
		if (!is.from.createAB(abatch)) {
			# This does not come from createAB, its an original affybatch
			if (!have.probe.control)
				spike.list <-  which(regexpr("^spike_in-control", names(l)) != -1)
			
			if (length(spike.list)==0)
				stop("Can not find any control probes. Please use another normalization method")
			
			# Call the low level spikeinnorm function
			m <- spikeinnorm(abatch, spike.list=spike.list, control.params=control.params, verbose=verbose, channel=0)
		} else {
			if (!have.probe.control)
				spike.list <-  which(regexpr("^spike_control", names(l)) != -1)
			if (length(spike.list)==0)
				stop("Can not find any control probes. Please use another normalization method")
			# If it is dual channel
			if (is.dual(abatch)) {
				if (verbose) {
					cat("Processing first channel...\n")
				}
				m1 <- spikeinnorm(object=abatch, spike.list=spike.list, control.params=control.params, verbose=verbose, channel = 1)
				if (verbose) {
					cat("Processing second channel...\n")
				}
				m2 <- spikeinnorm(object=abatch, spike.list=spike.list, control.params=control.params, verbose=verbose, channel = 2)
				m <- cbind(m1, m2)
			} else {
				# if it is single channel
				m <- spikeinnorm(object=abatch, spike.list=spike.list, control.params=control.params, verbose=verbose, channel = 0)
			}
		}
	} else {
		if (is.from.createAB(abatch)) {
			if (!normalize.method%in%c("quantile","median","mean")) {
				stop("Method not supported for the AffyBatch object provided")
			}
			if (normalize.method=="quantile") {
				if (is.dual(abatch)) {
					lim.obj <- new("RGList")
					lim.obj$G <- exprs(abatch)[,1:(ncol(exprs(abatch))/2)]
					lim.obj$R <- exprs(abatch)[,((ncol(exprs(abatch))/2)+1):(ncol(exprs(abatch)))]
#				if (has.bg(abatch)) {
#					lim.obj$Gb <- se.exprs(abatch)[,1:(ncol(exprs(abatch))/2)]
#					lim.obj$Rb <- se.exprs(abatch)[,((ncol(exprs(abatch))/2)+1):(ncol(exprs(abatch)))]
#				}
					#lim.MA <- normalizeWithinArrays(object = lim.obj, method = "loess")
					#lim.obj$R <- normalizeQuantiles(lim.MA$A + lim.MA$M/2)
					#lim.obj$G <- normalizeQuantiles(lim.MA$A - lim.MA$M/2)
					lim.obj$R <- 2 ^ normalizeQuantiles(log2(lim.obj$R))
					lim.obj$G <- 2 ^ normalizeQuantiles(log2(lim.obj$G))
					m <- cbind(lim.obj$G, lim.obj$R)		
				} else {
					# Single channel
					lim.obj <- new("EListRaw")
					lim.obj$E <- exprs(abatch)[,1:(ncol(exprs(abatch)))]
#				lim.obj$Eb <- NULL
#				if (has.bg(abatch)) {
#					lim.obj$Eb <- se.exprs(abatch)[,1:(ncol(exprs(abatch)))]
#				}
					m <- 2 ^ normalizeQuantiles(log2(lim.obj$E))
				}
			} else {
				if (normalize.method=="median") {
					m <- mediannorm(abatch)
					
				} else if (normalize.method=="mean") {
					m <- meannorm(abatch)
				}
			}
		} else {
#			if (!normalize.method%in%normalize.AffyBatch.methods()) {
#				stop("Method not supported for the AffyBatch object provided")
#			}
			# The abatch comes from Affy pipeline
			m <- exprs(normalize(abatch, method="quantiles"))
		}
	}
	ab <- abatch
	exprs(ab) <- m
	return(ab)
}


spikeinnorm <- function(	object,
		spike.list,
		control.params,
		channel,
		verbose=TRUE) {
	# Spike-in method implementation selects only spikes in the matrix
	galenv <- getCdfInfo(object)
	
	# log2 should not be done because it is done when calling background correction even if option = FALSE
	M <- log2(exprs(object))
	
	if (channel==0) {
		sample.start <- 1;
		sample.end <- length(sampleNames(object))
		channel.name <- "1"
	}
	else if (channel==1) {
		sample.start <- 1;
		sample.end <- length(sampleNames(object)) / 2
		channel.name <- "Green"
	}
	else if (channel==2) {
		sample.start <- length(sampleNames(object)) / 2 + 1;
		sample.end <- length(sampleNames(object))
		channel.name <- "Red"
	}
	
	nbsamples <- (sample.end - sample.start) + 1
	if (nbsamples==1) {
		stop("Can not do the spike calibration with only one sample.")
	}
	l <- mget(ls(galenv),galenv)
	
	# Get the median spike control matrix
	mss <- matrix(0, length(spike.list), nbsamples)
	mss.max <- matrix(0, length(spike.list), nbsamples)
	mss.min <- matrix(0, length(spike.list), nbsamples)
	
	spikeCounts <- vector()
	for(i in 1:length(spike.list)) {
		mat <- l[spike.list[i]]
		mat <- mat[[1]]
		
		for(j in 1:nbsamples) {
			if (j==1) {
				spikeCounts[i] <- length(M[mat[,1],(j+sample.start-1)])
			}
			mss[i,j] <- median(M[mat[,1],(j+sample.start-1)])
			mss.max[i,j] <- max(M[mat[,1],(j+sample.start-1)])
			mss.min[i,j] <- min(M[mat[,1],(j+sample.start-1)])
		}
	}
	# Check mean of coeficients (except diagonal) = Shared variance check
	cmat <- cor(t(mss))
	for(i in 1:nrow(cmat)) {
		cmat[i,i] <- 0
	}
	if (mean(cmat) < control.params$min.corr) {
		if (verbose) {
			mean.display <- floor(mean(cmat) * 100) / 100
			message("Not enough common variance to guarantee good performance of spike-in normalization (", mean.display, " < ", control.params$min.corr, ").\nUsing median normalization...")
		}
		# Call mediannorm
		return(mediannorm(object,channel=channel))
	}
	
	# Checking specificity of spike intensity
	#	vs <- vector()
	#	for(i in 1:nbsamples) {
	#		vs[i] <- (max(M[,i+sample.start-1])-min(M[,i+sample.start-1])) / length(spikeCounts)
	#	}
	if ( median(mss.max-mss.min) > control.params$max.log2span) {
		if (verbose) {
			v.max <- floor(control.params$max.log2span * 100) / 100 
			v.observed <- floor(median(mss.max-mss.min) * 100) / 100
			message("The intensity resolution of the spike-in probe sets is too coarse (",  v.observed, " > ", v.max, ") to guarantee a good performance of spike-in normalization\nUsing median normalization...")
		}
		# Call mediannorm
		return(mediannorm(object, channel=channel))
	}
	
	# Checking external coverage
	ve <- vector()
	for(i in 1:nbsamples) {
		ve[i] <- (max(mss[,i])-min(mss[,i])) / (max(M[,i+sample.start-1])-min(M[,i+sample.start-1]))
	}
	if (median(ve) < control.params$cover.ext) {
		if (verbose) {
			ve.display <- floor(median(ve) * 100) / 100 
			message("The ratio between the intensity range covered by the spike-in probes and the one covered by all probes on the array is too low (",  ve.display, " < ", control.params$cover.ext, ").\nUsing median normalization...")
		}
		# Call mediannorm
		return(mediannorm(object,channel=channel))
	}
	
	# Checking internal coverage
	vi <- vector()
	for(i in 2:nbsamples) {
		vi[i-1] <- max(mss[,i]-mss[,i-1])
	}
	if (median(vi) > control.params$cover.int) {
		if (verbose) {
			vi.display <- floor(median(vi) * 100) / 100 
			message("The size of the largest intensity interval between two consecutive spikes is too large (",  vi.display, " > ", control.params$cover.int, ").\nUsing median normalization...")
		}
		# Call mediannorm
		return(mediannorm(object,channel=channel))
	}
	
	# Use shorts names for spikes control
	if (is.from.createAB(object)) {
		tab <- strsplit(names(l[spike.list]), '_')
	}
	else {
		tab <- strsplit(names(l[spike.list]), '-')
	}
	spikeNames <- list()
	for(i in 1:length(tab)) { spikeNames[i] = tab[[i]][length(tab[[i]])] }
	rownames(mss) <- spikeNames
	colnames(mss) <- (sample.start):(sample.end)
	
	mu <- rowMeans(mss)
	sigma <- apply(mss, 1, sd)
	sigma <- sqrt((ncol(mss)-1)/ncol(mss)) * sigma # We want denominator n not n-1
	
	nss <- (mss - mu) / (sqrt(ncol(mss))*sigma)
	ns <-  colMeans(nss)
	ncss <- matrix(NA, nrow(mss), ncol(mss))
	for(i in 1:ncol(mss)) {ncss[,i] <- nss[,i] - ns[i]}
	mcss <- mu + sqrt(ncol(mss))*sigma * ncss
	
	msp <- vector()
	dmsp <- vector()
	for(s in 1:nbsamples) {
		tmp <- vector()
		dtmp <- vector()
		for(i in 1:length(spike.list)) {
			mat <- l[spike.list[i]]
			mat <- mat[[1]]
			if (i==1) {
				tmp <- as.vector(M[mat[,1],s + sample.start-1])
				dtmp <-as.vector(replicate(length(M[mat[,1],s + sample.start-1]), mcss[i,s]-mss[i,s]))
			}
			else {
				tmp <- append(tmp, as.vector(M[mat[,1],s + sample.start-1]))
				dtmp <- append(dtmp, as.vector(replicate(length(M[mat[,1],s + sample.start-1]), mcss[i,s]-mss[i,s])))
			}
		}
		msp <- cbind(msp, tmp)
		dmsp <- cbind(dmsp, dtmp)
	}
	colnames(msp) <- (sample.start):(sample.end)
	colnames(dmsp) <- (sample.start):(sample.end)
	
	mcsp <- msp + dmsp
	dM <- matrix(NA, nrow(M), nbsamples)
	Mout <- matrix(NA, nrow(M), nbsamples)
	
	if (control.params$figures.show) {
		ordered <- order(mss[,1])
		txt <- paste("Fig.1: Correction of spike-in probe set intensities (", channel.name, " channel)", sep="")
		if (control.params$figures.output=="display") {
			dev.new(title=txt)
		} else {
			filename <- paste("Spike-in_Probe_sets_Intensity_Correction_", channel.name, "_channel.pdf", sep="")
			pdf(file=filename, title=txt)
		}
		
		figure1 <- dev.cur()
		xLegend <- "Array labels"
		yLegend <- "Intensities (log2)"
		#layout(matrix(c(1,2,3,4,5,5), 3, 2, byrow = TRUE),c(3,3,3), c(3,3,1), TRUE)
		layout(matrix(c(1,2,3,4,5,3), 2, 3, byrow = TRUE),c(5,5,3), c(5,5,5), TRUE)
		par(xpd = NA)
		par(oma = c(0, 0, 0, 0))
		
		# Start: Uncorrected
		m <- t(mss[ordered,])
		matplot(m, 
				type="o", col = rainbow(nrow(mss)),
				pch=1:nrow(mss),
				lty=1,
				ylab = yLegend,
				xlab = xLegend,
				main = "Start: Uncorrected",
				axes = FALSE,
				cex = 0.8)
		axis(1, at = seq(1, nrow(m), by = 1))
		axis(2, at = seq(round(min(m)), round(max(m))))
		
		# Step #1: Centered-Normed
		m <- t(nss[ordered,])
		matplot(m, 
				type="o", col = rainbow(nrow(mss)),
				pch=1:nrow(mss),
				lty=1,
				ylab = yLegend,
				xlab = xLegend,
				main = "Step #1: Centered-Normed",
				axes = FALSE,
				cex = 0.8)
		axis(1, at = seq(1, nrow(m), by = 1))
		axis(2, at = seq(-0.75, 0.75, by=0.1))
		
		# Legend
		cols <- rainbow(nrow(mss))
		for(i in 1:nrow(mss)) {
			y <- c(i, i)
			if(i==1) {
				plot(0, i, axes=FALSE, ylim=c(-1.2, nrow(mss)+1), xlim=c(0,1.5), xlab="", ylab="", col=cols[i], pch=i)
			}
			else {
				points(0,i, col=cols[i], pch=i, cex=1.2)
			}
			text(1, y, labels=(spikeNames[ordered])[i]) 
		}
		legend("top", "Spike-in probe sets", bty="n")
		
		# Step #2: Corrected Center-Normed
		m <- t(ncss[ordered,])
		matplot(m, 
				type="o", col = rainbow(nrow(mss)),
				pch=1:nrow(mss),
				lty=1,
				ylab = yLegend,
				xlab = xLegend,
				main = "Step #2: Corrected Center-Normed",
				axes = FALSE,
				cex = 0.8)
		axis(1, at = seq(1, nrow(m), by = 1))
		axis(2, at = seq(round(min(m),1), round(max(m),1), by=0.05))
		
		# Final step: Corrected
		m <- t(mcss[ordered,])
		matplot(m, 
				type="o", col = rainbow(nrow(mss)),
				pch=1:nrow(mss),
				lty=1,	
				ylab = yLegend,
				xlab = xLegend,
				main = "Final step: Corrected",
				axes = FALSE,
				cex = 0.8)
		axis(1, at = seq(1, nrow(m), by = 1))
		axis(2, at = seq(round(min(m)), round(max(m))))
		
		#legend(-3, 3.5, spikeNames[ordered], col=rainbow(nrow(m)), lty=1:nrow(m) ,ncol = 3, cex = 1.0, pch="*")
		layout(1)
		if (!dev.interactive()) dev.off()
		
		txt <- paste("Fig.2: Performance of the spike-in probe set intensity correction (", channel.name, " channel)", sep="")
		if (control.params$figures.output=="display") {
			dev.new(title=txt)
		} else {
			filename <- paste("Performance_of_the_spike-in_probe_set_intensity_correction_", channel.name, "_channel.pdf", sep="")
			pdf(file=filename, title=txt)
		}
		figure2 <- dev.cur()
		nf <- layout(matrix(c(1,2,3,0), 2, 2, byrow=TRUE), c(4,1))
		cmat <- cor(t(mss))
		cmin <- 0
		cmax <- 1
		csize <- ncol(cmat)
		
		ColorRamp <- rgb( seq(0,1,length=256),
				seq(1,0,length=256),
				seq(0,0,length=256))
		ColorLevels <- seq(cmin, cmax, length=length(ColorRamp))
		
		# Data Map
		nb.sources <- 10000
		heat.source <- heat.colors(nb.sources)
		index.map <- vector()
		for(i in 1:nb.sources)
		{
			index.map[i] = 2/pi * asin(i/nb.sources)
		}
		
		heat.panel <-  round(index.map * 128)
		res <- which(!duplicated(heat.panel))
		heat.panel <- heat.source[res]
		
		image(1:csize, 1:csize, t(cmat)[ordered,ordered], col=rev(heat.panel), xlab="Spike-in probe sets", ylab="Spike-in probsets", zlim=c(cmin,cmax), main="Pearson correlation between \nuncorrected spike-in probe sets", axes=FALSE)
		axis(1, at = seq(1, csize, by = 1),(spikeNames[ordered])[1:csize])
		axis(2, at = seq(1, csize, by = 1),(spikeNames[ordered])[1:csize])
		
		# Color Scale
		image(1, ColorLevels,
				matrix(data=ColorLevels, ncol=length(ColorLevels),nrow=1),
				col=rev(heat.panel),
				xlab="",ylab="",
				xaxt="n")
		
		ratio <- (apply(t(mcss),2, var) / apply(t(mss),2, var))[ordered]
		#rownames(ratio) <- spikeNames
		max.ratio <- max(ratio)
		if ( max.ratio <= 1) max.ratio <- 1 
		barplot(ratio,main="Variance ratio after/before correction\nfor spike-in probe set intensities", axes=FALSE, ylim=c(0,max.ratio), col=rainbow(nrow(mcss)), xlab="Spike-in probe sets", ylab="Variance ratio")
		axis(2, at = seq(0,max.ratio,by=0.1))
		# ylab="Corrected variance/Uncorrected variance", xlab="Spike probesets"
		layout(1)
		if (!dev.interactive()) dev.off()
	}
	
	# Set the linit of samples viewed on figure
	max.samplesviewed <- 10
	
	# Set the default loess span value
	if (control.params$loess.span == -1) control.params$loess.span <- 5.0/nrow(mss)
	
	# Compute the number of points to use for extrapolation based of spike control extrap.points needed
	spikeset.order <- order(mss[,1])
	nbpoints <- 0
	
	for(p in 1:(control.params$extrap.points)) {
		nbpoints <- nbpoints + (spikeCounts[spikeset.order])[p] 
	}
	
	points.all <- list()
	for(s in 1:nbsamples) {
		# Sort spike probe signal and correction matrices by intensity
		o <- order(msp[,s])
		x <- msp[o,s]
		y <- dmsp[o,s]
		# Get the number of integer values that need to be extrapoled to cover the all signal
		xa <- seq(from=ceiling(max(x)), to=ceiling(max(M)))
		# Check if number of points needed to be extrapoled are more than 50% of the number of spikes
		#if (length(xa) / length(spikeCounts) > 0.5) {
		#	if (verbose) {
		#		message("The number of points that have to be extrapoled is too high to perform spike-in normalization.\nUsing median normalization...")
		#	}
		#	return(mediannorm(object,channel=channel))
		#}
		
		lenx <- length(x)
		leny <- length(y)
		
		# Compute extrapolation for the queue by doing a regression with the extrap.points last sets
		nbrep <- median(spikeCounts)
		xf <- vector()
		for(i in 1:length(xa)) {
			xf <- c(xf, rep(xa[i], nbrep))
		}
		
		if (control.params$force.zero) {
			# Bug fix, if there are some zeros in the expression matrix, log2 will give -Inf
			# Get the minimum intensity which is not zero
			xb <- rep(min(M[which(M>0)]), (spikeCounts[spikeset.order])[1])
			xe <- c(xb, x, xf)
		}
		else {
			# Bug fix, if there are some zeros in the expression matrix, log2 will give -Inf
			# Get the minimum intensity which is not zero
			xe <- c(min(M[which(M>0)]), x, xf)
		}
		
		if (control.params$extrap.method == "mean") {
			meany <- mean(y[(leny-nbpoints):(leny)])
			prediction <- rep(meany, length(xf))
		}
		else {
			if (control.params$extrap.method == "linear") {
				qdata <- data.frame(x=x[(lenx-nbpoints-1):(lenx)], y=y[(leny-nbpoints-1):(leny)])
				fit <- lm(y ~ x, data=qdata )
				prediction <- predict(fit, data.frame(x=xf))
			}
			else {
				stop("extrap.method not supported")
			}
		}
		
		if (control.params$force.zero) {
			ye <- c(rep(0, (spikeCounts[spikeset.order])[1]), y, prediction)	
		}
		else {
			ye <- c(median(y[1:(spikeCounts[spikeset.order])[1]]), y, prediction)
			#ye <- c(y, prediction)
		}
		
		lo.res <- loess.smooth(xe, ye, span=control.params$loess.span)
		if (control.params$figures.show) {
			points.all[[s]] <- list()
			points.all[[s]]$x <- xe
			points.all[[s]]$y <- ye
			points.all[[s]]$lo <- lo.res
		}
		dM[,s] <- (approx(x=lo.res$x, y=lo.res$y, xout=M[,s]))$y
	}
	
	if (control.params$figures.show) {
		by.samples.figures(points.all, channel.name,figures.output=control.params$figures.output)
	}
	
	Mout <- M[,(sample.start):(sample.end)] + dM
	Mout <- 2 ^ Mout
	return(Mout)
}

by.samples.figures <- function(data, channel, figures.output=c("display","file")) {
	figures.output <- match.arg(figures.output)
	max.samples <- 20
	nbsamples <- length(data)
	nb.figures <- ceiling(nbsamples / max.samples)
	for(i in 1:nb.figures) {
		if ((i*max.samples) > nbsamples) {
			to <- nbsamples
		}
		else {
			to <- i * max.samples
		}
		from <- (i-1) * max.samples + 1		
		txt <- paste("Correction functions (channel ", channel, ") arrays ", from, " to ", to, sep="")
		if (figures.output=="display") {
			dev.new(title=txt)
		} else {
			filename <- paste("Correction_functions_channel_", channel, "_arrays_", from, "_to_", to,".pdf",sep="")
			pdf(file=filename, title=txt)
		}
		def.par <- par(no.readonly = TRUE)
		par(xpd = NA)
		par(oma = c(0, 0, 0, 0))
		nf <- layout(matrix(c(1,2), 1, 2, byrow=TRUE), c(3,1), c(3,3), TRUE)
		by.samples.curve(data, from, to)
		by.samples.legend(from, to)
		layout(1)
		if (!dev.interactive()) dev.off()
	}
}


by.samples.curve <- function(data, sample.from, sample.to) {
	nbsamples <-  sample.to - sample.from + 1
	title <- paste("Correction functions for raw intensity normalization\n(arrays ",sample.from, " to ", sample.to,")", sep="")
	
	dataloy.vect <- vector()
	for(s in 1:nbsamples) {
		index <- s + sample.from - 1
		dataloy.vect <- c(dataloy.vect, data[[index]]$lo$y)
		dataloy.vect <- c(dataloy.vect, data[[index]]$y)
	}
	min.value <- min(dataloy.vect)
	max.value <- max(dataloy.vect)
	
	for(s in 1:nbsamples) {
		index <- s + sample.from - 1
		if (s  == 1) {
			# this is a new figure on the layout
			plot(data[[index]]$x,data[[index]]$y, ylim=c(min.value, max.value), col=s, cex=0.72, pch=s, main=title, xlab="Raw intensities", ylab="Correction functions")
		} else {
			points(data[[index]]$x, data[[index]]$y, col=s, pch=s, cex=0.72)
		}
		lines(data[[index]]$lo,col=s,pch=s)
	}
}

by.samples.legend <- function(sample.from, sample.to) {
	
	nbsamples <-  sample.to - sample.from + 1
	for(s in 1:nbsamples) {
		index <- s + sample.from - 1
		if (s == 1) {
			plot(-0.5, s, axes=FALSE, ylim=c(0, nbsamples+2), xlim=c(0,1.5), xlab="", ylab="", col=s, pch=s)
		}
		else {
			points(-0.5,s, col=s, pch=s, cex=1.2)
		}
		text(1.5, s, labels=(s+sample.from-1), cex=0.6)
	}
	legend(x=-0.5, y=nbsamples+2, "Array labels", bty="n", cex=0.7)
}

meannorm <- function(object, channel=0) {
	if (channel==0) {
		m <- exprs(object)
	} else if (channel==1) {
		m <- exprs(object)[,1:length(sampleNames(object)) / 2]
	} else {
		m <- exprs(object)[,(length(sampleNames(object)) / 2 + 1):(length(sampleNames(object)))]
	}
	m <- exprs(object)
	m <- log2(m)
	cm <- colMeans(m)
	m2 <- m
	for(i in 1:nrow(m)) {
		m2[i,] <- m2[i,] - cm
	}
	m <- m - min(m)
	m <- 2 ^ m
	return(m)
}


mediannorm <- function(object, channel=0) {
	if (channel==0) {
		m <- exprs(object)
	} else if (channel==1) {
		m <- exprs(object)[,1:(length(sampleNames(object)) / 2)]
	} else {
		m <- exprs(object)[,(length(sampleNames(object)) / 2 + 1):(length(sampleNames(object)))]
	}
	m <- log2(m)
	md <- apply(m, 2, median)
	m2 <- m
	for(i in 1:nrow(m)) {
		m2[i,] <- m2[i,] - md
	}
	m <- m - min(m)
	m <- 2 ^ m
	return(m)
}

summarize.miR <- function(
		abatch,
		pmcorrect.method = 'pmonly',
		pmcorrect.param = list(),
		summary.method = 'medianpolish',
		summary.param = list(),
		summary.subset = NULL) {
	if (is.null(summary.method)) {
		stop("Please specify a summarization method, for example: 'medianpolish'")
	}
	
	if (is.null(pmcorrect.method)) {
		if (!is.from.createAB(abatch)) {
			stop("Please specify a pmcorrect method, for example: 'pmonly'")
		} else {
			pmcorrect.method = "pmonly"
		}
	}
	
	
	#pm correct
	if (pmcorrect.method != "pmonly") {
		if (!is.from.createAB(abatch)) {
			if(all(is.na(mm(abatch)))) {
				warning("No mismatch probes specified in the CDF file, using pmcorrect.method='pmonly'")
				pmcorrect.method = "pmonly"
			}
		} else {
			pmcorrect.method = "pmonly"
		}
	}
	return(computeExprSet(abatch, pmcorrect.method=pmcorrect.method,
					summary.method=summary.method, summary.param=summary.param,
					ids=summary.subset, pmcorrect.param=pmcorrect.param ))	
}


is.from.createAB <- function(object) {
	return(any("ExiMiR.channel"%in%names(notes(object))))
}

is.dual <- function(object) {
	if (!is.from.createAB(object))
		FALSE
	else {
		if (notes(object)$ExiMiR.channel == "Dual channel") {
			TRUE
		} else {
			FALSE
		}
	}
}

has.bg <- function(object) {
	if (!is.from.createAB(object))
		FALSE
	else {
		if (notes(object)$ExiMiR.bg == "Contains background") {
			TRUE
		} else {
			FALSE
		}
	}
}

# File: createAB.R
# 
# Author: Sylvain Gubian, Alain Sewer, PMP SA
# Aim: Creating an affybatch from a RGList, EListRaw, MAList or List object
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.

#########################################################################################

createAB <- function(object,
		 verbose=TRUE,
         ref.channel = "R",
         genes.block=NULL,
         genes.row=NULL,
         genes.col=NULL,
         genes.id=NULL,
         genes.name=NULL,
         galname=NULL,
         env.overwrite = TRUE,
         ...) {
	if (class(object)!="RGList" && class(object)!="MAList" && class(object)!="List" && class(object)!="EListRaw") {
		stop(paste("Object of class",class(object),"not supported"))
	}
	
	if (is.null(object$genes)) {
		stop("No genes field in specified Limma List object ")
	}
	obj <- object
	if (class(object)=="MAList") {
		obj <- new("RGList")
		obj$R <- object$A  + object$M/2
		obj$G <- object$A  - object$M/2
		obj$genes <- object$genes
		if (!is.null(object$printer)) {
			obj$printer <- object$printer
		}
	}
	if (is.null(obj$source)) {
		obj$source <- "other"
	}
	
	if (!all(ref.channel%in%c("G","R"))) {
		stop(paste(" ref.channel:", ref.channel, "not supported, use either 'R' (default) or 'G'"))
	}
	
	gal.env.ready <- FALSE
	if (!is.null(galname)) {
		if (exists(x=galname)) {
			if (!isTRUE(env.overwrite)) {
				if (isTRUE(verbose)) {
					cat(paste("Using existing environment:",galname,"\n"))
				}
				gal.env.ready <- TRUE
				galenv <- get(galname)
			} else {
				if (isTRUE(verbose)) {
					cat(paste("Warning: Overwritting", galname, "environment\n"))
				}
			}
		}
	} else {
		galname = paste("galenv.", obj$source,".", format(Sys.time(), "%Y%m%d%H%M%S"),round(runif(1)*1e3),sep="")
	}
	
	is.dual <- TRUE
	
	if (!all(c("R", "G")%in%(names(obj)))) {
		if (all(c("E")%in%names(obj))) {
			is.dual <- FALSE
		} else {
			stop("RGList or EListRaw object specified does not contain R,G or E fields")
		}
	}
	has.bg <- TRUE
	if (!any(c("Rb","Gb","Eb")%in%names(obj))) {
		has.bg <- FALSE
	}
	
	has.rowcols <- FALSE
	
	if (is.dual) {
		filenames <- unlist(strsplit(x=colnames(obj$G),fixed=TRUE,split="."))
		if (length(filenames) > length(colnames(obj))) {
			if (length(filenames) == length(colnames(obj))*4) {
				filenames <- filenames[seq(from=1, to=length(filenames), by=2)]
			}
		}
	} else {
		filenames <- colnames(obj$E)
	}
	
	# Preparing arguments for initializing Affybatch
	dots <- list(...)
	
	if (is.dual) {
		if (obj$source == 'imagene' || obj$source == 'exiqon') {
			evens <- filenames[seq(from=2, to=length(filenames),by=2)]
			odds <- filenames[seq(from=1, to=length(filenames),by=2)]
			colnames(obj$G) <- odds
			colnames(obj$R) <- evens
			if (has.bg) {
				colnames(obj$Gb) <- odds
				colnames(obj$Rb) <- evens
			}
		}
		else {
			colnames(obj$G) <- filenames
			colnames(obj$R) <- filenames
		}
	}
	
	# Check annotation
	gal.read <- FALSE
	
	if (all(c("Block","Column","Row","ID","Name")%in%colnames(obj$genes))) {
		# Exiqon or Agilent with annotation given by GAL file
		gal.read <- TRUE
		IDS <- obj$genes$ID
		GNAMES <- obj$genes$Name
		BLOCKS <- obj$gene$Block
		COLS <- obj$gene$Column
		ROWS <- obj$gene$Row
		has.rowcols <- TRUE
	} else if (all(c("Field","Column","Row")%in%colnames(obj$genes)))	{
		# Exiqon or Agilent with default genes field
		if (!all(c("Gene ID","names")%in%colnames(obj$genes))) {
			# names and id of genes missing in genes field
			stop("genes field of given object does not contain any annotation")
		}
		cat('Warning: GAL file has not been provided:\n')
		cat("This might cause some functionalities not to work properly (e.g. AffyBatch image).\n")
		IDS <- obj$genes$'Gene ID'
		GNAMES <- obj$genes$names
		BLOCKS <- as.integer(gsub(" ", "",gsub("[^[:digit:]]", " ", obj$gene$Field)))
		ROWS <- as.integer(obj$gene$Row)
		COLS <- as.integer(obj$gene$Column)
		has.rowcols <- TRUE
	} else if (all(c("Row","Col","ProbeUID","GeneName")%in%colnames(obj$genes))) {
		# Agilent chip
		IDS <- obj$genes$ProbeUID
		GNAMES <- obj$genes$GeneName
		BLOCKS <- rep(1,length(obj$gene$Row))
		COLS <- obj$gene$Col
		ROWS <- obj$gene$Row
		BLOCKS <- rep(1, length(ROWS))
		has.rowcols <- TRUE
		NROWS <- max(ROWS)
		NCOLS <- max(COLS)
	} else {
		if (is.null(genes.id) || is.null(genes.name)) {
			stop("Genes field mapping are missing.")
		} else {
			if (!all(c(genes.id,genes.name)%in%colnames(obj$genes))){
				stop("Specified genes field mapping are not found in the specified RGList or EList object")
			}
			if (is.null(genes.row) || is.null(genes.col)) {
				if (!is.dual) {
					COLS <- rep(1, nrow(obj$E))
					ROWS <- 1:(nrow(obj$E))	
				} else {
					COLS <- rep(1, nrow(obj$G))
					ROWS <- 1:(nrow(obj$G))
				}
			} else {
				ROWS <- obj$genes[genes.row]
				COLS <- obj$genes[genes.col]
				has.rowcols <- TRUE
			}
			NROWS <- max(ROWS)
			NCOLS <- max(COLS)
			IDS <- obj$genes[genes.id]
			IDS <- IDS[,1]
			GNAMES <- obj$genes[genes.name]
			GNAMES <- GNAMES[,1]
			
			if (is.null(genes.block)) {
				BLOCKS <- rep(1, length(ROWS))
			} else {
				BLOCKS <- obj$genes[genes.block]
			}
		}
	}
	
	# Check printer
	if (is.null(obj$printer) && has.rowcols) {
		cat("Printer is not defined. Assumes that Row index and Col index correspond to the physical coordinates on the chip\n")
	} else if (!has.rowcols) {
		cat("Rows, Cols are not given, image method of the AffyBatch object won't be supported\n")
	}
	
	if (is.null(obj$printer)) {
		perm.list <- NULL
	} else {
		perm.list <- list()
		if (gal.read | (obj$source != 'exiqon' & obj$source !='imagene')) {
			# Can use printer
			perm.list$block.row <- obj$printer$ngrid.r
			perm.list$block.col <- obj$printer$ngrid.c
		} else {
			perm.list$block.row <- 12 #TODO put modulo
			perm.list$block.col <- 4
		}
		bi <- (BLOCKS-1) %/% perm.list$block.col  + 1
		bj <- (BLOCKS-1) %% perm.list$block.col + 1
		NROWS <- obj$printer$nspot.r
		NCOLS <- obj$printer$nspot.c
		perm.list$rindex <- ROWS + (bi-1) * NROWS
		perm.list$cindex <- COLS + (bj-1) * NCOLS
		perm.list$vect <- vector()
		perm.list$vect <- perm.list$rindex + (perm.list$cindex-1) * max(perm.list$rindex)
	}
	annotation.struct <- list(IDS=IDS, GNAMES=GNAMES, BLOCKS=BLOCKS, COLS=COLS, ROWS=ROWS, NROWS=NROWS, NCOLS=NCOLS)
	if (!gal.env.ready) {
		galenv <- create.gal.env(galname, struct = annotation.struct, perm=perm.list)
	}
	
	# Create Affybacth matrix for permutation
	if (!is.null(perm.list)) {
		file.rep = FALSE
		if (obj$source != 'imagene' & obj$source != 'exiqon') {
			file.rep = TRUE
			mR.temp <- matrix(NA, max(perm.list$rindex), max(perm.list$cindex))
			mG.temp <- matrix(NA, max(perm.list$rindex), max(perm.list$cindex))
			mbgR.temp <- matrix(NA, max(perm.list$rindex), max(perm.list$cindex))
			mbgG.temp <- matrix(NA, max(perm.list$rindex), max(perm.list$cindex))
			signal <- matrix(NA, length(ROWS), length(filenames)*2)
			bg <- matrix(NA, length(ROWS), length(filenames)*2)
		} else {
			m.temp <- matrix(NA, max(perm.list$rindex), max(perm.list$cindex))
			mbg.temp <- matrix(NA, max(perm.list$rindex), max(perm.list$cindex))
			signal <- matrix(NA, length(ROWS), length(filenames))
			bg <- matrix(NA, length(ROWS), length(filenames))
		}
		
		
		for(i in 1:length(filenames)) {
			for(j in 1:length(ROWS)) {
				if (is.dual) {
					if (!file.rep) {
						if (i <= length(filenames)/2) {
							if (ref.channel=="G")
								m.temp[perm.list$rindex[j],perm.list$cindex[j]] <- obj$G[j,i]
							else
								m.temp[perm.list$rindex[j],perm.list$cindex[j]] <- obj$R[j,i]
							if (has.bg)
								if (ref.channel=="G")
									mbg.temp[perm.list$rindex[j],perm.list$cindex[j]] <- obj$Gb[j,i]
								else
									mbg.temp[perm.list$rindex[j],perm.list$cindex[j]] <- obj$Rb[j,i]
						} else {
							if (ref.channel=="G")
								m.temp[perm.list$rindex[j],perm.list$cindex[j]] <- obj$R[j,i-length(filenames)/2]
							else
								m.temp[perm.list$rindex[j],perm.list$cindex[j]] <- obj$G[j,i-length(filenames)/2]
							if (has.bg)
								if (ref.channel=="G")
									mbg.temp[perm.list$rindex[j],perm.list$cindex[j]] <- obj$Rb[j,i-length(filenames)/2]
								else
									mbg.temp[perm.list$rindex[j],perm.list$cindex[j]] <- obj$Gb[j,i-length(filenames)/2]
						}
					} else { # NON AGILENT/EXIQON
						if (ref.channel=="G") {
							mG.temp[perm.list$rindex[j],perm.list$cindex[j]] <- obj$G[j,i]
							mR.temp[perm.list$rindex[j],perm.list$cindex[j]] <- obj$R[j,i]
						} else {
							mG.temp[perm.list$rindex[j],perm.list$cindex[j]] <- obj$R[j,i]
							mR.temp[perm.list$rindex[j],perm.list$cindex[j]] <- obj$G[j,i]
						}
						if (has.bg)
							if (ref.channel=="G") {
								mbgG.temp[perm.list$rindex[j],perm.list$cindex[j]] <- obj$Gb[j,i]
								mbgR.temp[perm.list$rindex[j],perm.list$cindex[j]] <- obj$Rb[j,i]
							} else {
								mbgG.temp[perm.list$rindex[j],perm.list$cindex[j]] <- obj$Rb[j,i]
								mbgR.temp[perm.list$rindex[j],perm.list$cindex[j]] <- obj$Gb[j,i]
							}
					}
				} else {
					m.temp[perm.list$rindex[j],perm.list$cindex[j]] <- obj$E[j,i]
					if (has.bg)
						mbg.temp[perm.list$rindex[j],perm.list$cindex[j]] <- obj$Eb[j,i]
				}
			}
			#m.temp <- m.temp[,rev(1:max(perm.env$cindex))]
			if (file.rep) {
				mbgG.temp <- mbgG.temp[,(1:max(perm.list$cindex))]
				mbgR.temp <- mbgR.temp[,(1:max(perm.list$cindex))]
				signal[,i] <- as.vector(mG.temp)
				signal[,i+length(filenames)] <- as.vector(mR.temp)
			} else {
				m.temp <- m.temp[,(1:max(perm.list$cindex))]
				signal[,i] <- as.vector(m.temp)
			}
			if (has.bg) {
				if (file.rep) {
					mbgR.temp <- mbgR.temp[,(1:max(perm.list$cindex))]
					mbgG.temp <- mbgG.temp[,(1:max(perm.list$cindex))]
					bg[,i] <- as.vector(mbgG.temp)
					bg[,i+length(filenames)/2] <- as.vector(mbgR.temp)
				} else {
					mbg.temp <- mbg.temp[,(1:max(perm.list$cindex))]
					bg[,i] <- as.vector(mbg.temp)
				}
			}	
		}
	} else {
		if (has.bg)
			min.sig <- min(obj$Eb)
		else
			min.sig <- min(obj$E)
		signal <- matrix(min.sig,NROWS*NCOLS, length(filenames))
		bg <- matrix(min.sig, NROWS*NCOLS, length(filenames))
		msig <- matrix(min.sig, NROWS , NCOLS)
		mbg <-  matrix(min.sig, NROWS , NCOLS)
		for(j in 1:length(filenames)) {
			if (!is.dual) {
				for(i in 1:length(ROWS)) {
					msig[ROWS[i],COLS[i]] <- obj$E[i,j]
					if (has.bg)
						mbg[ROWS[i],COLS[i]] <- obj$Eb[i,j]
				}
			} else {
				if (j <= length(filenames)/2) {
					if (ref.channel=="G")
						msig[ROWS[i],COLS[i]] <- obj$G[i,j]
					else
						msig[ROWS[i],COLS[i]] <- obj$R[i,j]
					if (has.bg)
						if (ref.channel=="G")
							mbg[ROWS[i],COLS[i]] <- obj$Gb[i,j]
						else
							mbg[ROWS[i],COLS[i]] <- obj$Rb[i,j]
				} else {
					if (ref.channel=="G")
						msig[ROWS[i],COLS[i]] <- obj$R[i,j]
					else
						msig[ROWS[i],COLS[i]] <- obj$G[i,j]
					if (has.bg)
						if (ref.channel=="G")
							mbg[ROWS[i],COLS[i]] <- obj$Rb[i,j]
						else
							mbg[ROWS[i],COLS[i]] <- obj$Gb[i,j]
				}
			}
			signal[,j] <- as.vector(msig)
			bg[,j] <- as.vector(mbg)
		}
	}
	if (isTRUE(verbose))
		cat(paste("instantiating an AffyBatch (exprs matrix dimensions is", length(ROWS), "x", length(filenames), ")\n"))
	
	dots <- list(...)
	
	if (!"experimentData" %in% names(dots)) {
		experimentData <- new("MIAME")
	}
	if ("description" %in% names(dots)) {
		warning("use 'experimentData' rather than 'description' for experiment description")
	}
	if ("notes" %in% names(dots)) {
		## warning("addding 'notes' to 'experimentData'")
		notes(experimentData) <- c(notes(experimentData), dots[["notes"]])
	}
	
	if (is.dual) {
		if (file.rep) {
			fnG <- paste(filenames,'_G', sep='')
			fnR <- paste(filenames,'_R', sep='')
			if (ref.channel=="G") {
				filenames <- c(fnG, fnR)
			} else {
				filenames <- c(fnR, fnG)
			}
			pdata <- data.frame(sample=1:length(filenames), row.names=filenames)
		} else {
			pdata <- data.frame(sample=1:length(filenames), row.names=c(filenames[seq(from=1,
										to=length(filenames),by=2)],filenames[seq(from=2, to=length(filenames),by=2)]))
		}
	} else {
		pdata <- data.frame(sample=1:length(filenames), row.names=filenames)
	}
	
	if (!"phenoData" %in% names(dots)) {
		phenoData <- new("AnnotatedDataFrame",
				data=pdata,
				varMetadata=data.frame(
						labelDescription="arbitrary numbering",
						row.names="sample"))
	} else {
		phenoData <- dots[["phenoData"]] 
		pData(phenoData) <- pdata
	}
	
	if (!"featureData" %in% names(dots)) {
		featureData = new("AnnotatedDataFrame")
	} else {
		featureData = dots[["featureData"]]
	}
	
	if (!"protocolData" %in% names(dots)) {
		protocolData = phenoData[,integer(0)]
	} else {
		protocolData = dots[["protocolData"]]
	}
	
	#notes(experimentData)$ExiMiR.channel <- c(notes(experimentData), "Created by ExiMiR")
	if (is.dual)
		notes(experimentData)$ExiMiR.channel <-  "Dual channel"
	else
		notes(experimentData)$ExiMiR.channel <- "Single channel"
	if (has.bg)
		notes(experimentData)$ExiMiR.bg <- "Contains background"
	else
		notes(experimentData)$ExiMiR.bg <- "No background"
	
	
	# Add a tag in notes slot
	if (obj$source == "imagene" || obj$source == "exiqon") {
		ab <- new("AffyBatch",
				exprs =signal,
				se.exprs = bg,
				cdfName = galname,
				phenoData = phenoData,
				nrow = nrow(m.temp),
				ncol = ncol(m.temp),
				annotation = galname,
				protocolData = protocolData,
				experimentData = experimentData)
	} else if (obj$source == 'genepix') {
		ab <- new("AffyBatch",
				exprs =signal,
				se.exprs = bg,
				cdfName = galname,
				phenoData = phenoData,
				nrow = nrow(mG.temp),
				ncol = ncol(mR.temp),
				annotation = galname,
				protocolData = protocolData,
				experimentData = experimentData)
	} else {
		ab <- new("AffyBatch",
				exprs =signal,
				se.exprs = bg,
				cdfName = galname,
				phenoData = phenoData,
				nrow = NROWS,
				ncol = NCOLS,
				annotation = galname,
				protocolData = protocolData,
				experimentData = experimentData)
	}
	return(ab)
}


get.bg.ab <- function(x, signature="AffyBacth") {
	ab <- new("AffyBatch",
			exprs =se.exprs(x),
			se.exprs = exprs(x),
			cdfName = cdfName(x),
			phenoData = phenoData(x),
			nrow = nrow(x),
			ncol = ncol(x),
			annotation = annotation(x),
			protocolData = protocolData(x),
			description= description(x),
			notes = notes(x))
	#nrows <- nrow(exprs(ab)) / 2
	#ncols <- ncol(exprs(ab)) 
	#exprs(ab) <- exprs(x)[(nrows+1):(nrows*2),]
	#se.exprs(ab) <- exprs(x)[(nrows+1):(nrows*2),]
	return(ab)
}


bg.image <- function(x, signature="AffyBacth") {
	image(x,type="se.exprs" )
}

bg.hist <- function(x, signature="AffyBacth") {
	ab <- get.bg.ab(x)
	hist(ab)
}

bg.boxplot <- function(x,signature="AffyBacth") {
	ab <- get.bg.ab(x)
	boxplot(ab)
}

# File: read.exi.R
# 
# Author: sylvain.gubian@pmi.com
# Aim: Read an exiqon file, maps it with the GAL file and return an exi.batch R structure

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.

#########################################################################################


ReadExi <- function(
		txtfile.path= getwd(),
		galname= NULL,
		description = NULL,
		notes = '',
		rm.background = FALSE,
		verbose=TRUE) {
	# Check if the path is a directory
	if (!file.info(txtfile.path)[['isdir']])
		stop('txtfile.path given as argument is not folder!')
	
	if (isTRUE(rm.background)) {
		if (isTRUE(verbose)) {
			cat("rm.background argument is not supported in ReadExi anymore. See NormiR function for background correction\n")
		}
	}
	
	# For backward compatibility (using the sampleinfo.txt)
	# List files in this directory
	filenames <- list.files(txtfile.path)
	
	# Look if there is a samplesinfo.txt file
	sampleInfoIndex = which(regexpr("samplesinfo.txt", filenames) !=-1)
	
	if (length(sampleInfoIndex) == 0) {
		sampleInfoIndex = which(regexpr("Samplesinfo.txt", filenames) !=-1)
		if (length(sampleInfoIndex) == 0) {
			stop("Error: File 'Samplesinfo.txt' or 'samplesinfo.txt' not found!")
		}
	}
	
	is.h <- TRUE
	targets <- readTargets( file.path(path.expand(txtfile.path),'/samplesinfo.txt'))
	if (!all(c("Cy3","Cy5")%in%colnames(targets))) {
		if (!all(c("Hy3","Hy5")%in%colnames(targets))) {
			stop("Hy3 (or Cy3) and/or Hy5 (or Cy5) columns labels not found in sampleinfo.txt file")	
		} else {
			is.h <- TRUE
		}
	} else {
		is.h <- FALSE
	}
	
	if (is.h) {
		files <- targets[,c("Hy3","Hy5")]
	} else {
		files <- targets[,c("Cy3","Cy5")]
	}
	RG <- read.maimages(files, source="imagene", verbose=verbose, path=txtfile.path)
	
	# Read just one file for getting the annotations in case gal is not provided
	if (is.null(galname)) {
		names <- read.annotation.fromfile(path=txtfile.path, files=files[[1]][1],refIDs=RG$genes$'Gene ID')
		RG$genes <- cbind(RG$genes, names)
	} else {
		galfile.info.found <- TRUE
		# Retrieve the gal.info in the env
		galfile.env.name <- paste(galname,".envfile", sep="")
		if (exists(galfile.env.name)) {
			galfile.env <- get(galfile.env.name)
			if (exists("galfile.info", envir = galfile.env)) {
				galfile.info <- get("galfile.info", envir = galfile.env)
				if (!is.null(galfile.info$path) && !is.null(galfile.info$filename)) {
					RG$genes <- readGAL(galfile=galfile.info$filename, path=galfile.info$path)
					RG$printer <-  getLayout(RG$genes)
				} else {
					galfile.info.found <- FALSE
				}		
			} else {
				galfile.info.found <- FALSE				
			}
		} else {
			galfile.info.found <- FALSE	
		}
		if (!isTRUE(galfile.info.found)) {
			cat(paste("Warning: No environment found for GAL file info related to", galname,". Annotation from raw files is used.\n"))
			names <- read.annotation.fromfile(path=txtfile.path, files=files[[1]][1],refIDs=RG$genes$'Gene ID')
			head(RG$genes)
			RG$genes <- cbind(RG$genes, names)
			head(RG$genes)
		}
	}
	RG$source <- "exiqon"
	if (!is.null(galname)) {
		if (galfile.info.found) {
			ab <- createAB(RG,notes,description,galname = galname,verbose = verbose,env.overwrite=FALSE, ref.channel='R')
		} else {
			ab <- createAB(RG,notes,description,galname = galname,verbose = verbose,env.overwrite=TRUE, ref.channel='R')
		}
	} else {
		ab <- createAB(RG,notes,description,galname = NULL, verbose = verbose, ref.channel='R')
	}
	if (verbose) {
		cat("done.\n")
	}
	return(ab)
}

read.annotation.fromfile <- function(path, files, refIDs) {
	for.annotation <- read.maimages(path=path, files=files, green.only=TRUE,
			columns=list(G="Signal Median", Gb="Background Median"),
			annotation=c("Gene ID","Name"), verbose=FALSE)
	non.na.records <-  which(!is.na(for.annotation$genes$'Gene ID'))
	ids <- for.annotation$genes$'Gene ID'[non.na.records]
	names <- for.annotation$genes$Name[non.na.records]
	if (sum(ids - refIDs) != 0) {
		stop("Annotation and Gene ID matching problem")
	}
	return(for.annotation$genes$Name[non.na.records])
	RG$genes <- cbind(RG$genes, names)
}

%\VignetteIndexEntry{Description of ExiMiR}

\documentclass[11pt,a4paper]{article}
\usepackage[OT1]{fontenc}
\usepackage{graphicx}
\usepackage{hyperref}
\usepackage{Sweave}
\usepackage{subfigure}
\usepackage{textcomp}
\usepackage{fancyvrb}
\DeclareGraphicsExtensions{.png}
\graphicspath{{images}}

\textwidth=6.2in
\textheight=8.5in
%\textheight=9.0in
%\parskip=.3cm
\oddsidemargin=.1in
\evensidemargin=.1in
\headheight=-.3in

\renewcommand{\thefootnote}{\alph{footnote}}

\begin{document}
\title{Description of \emph{ExiMiR}}
\author{Sylvain Gubian, Alain Sewer, PMP SA}

\maketitle
\tableofcontents

\section{Introduction}

The \emph{ExiMiR} package provides tools for normalizing miRNA expression data obtained
primarily from Exiqon miRCURY LNA\texttrademark\ arrays (though other formats are supported
as well). It gives the possibility of applying a
novel miRNA-specific normalization method using spike-in probes and is based on
controlled assumptions \cite{bibi}. These features allow to take into account the
differences between miRNA and gene (mRNA) expression data, as discussed in a recent
study \cite{sarkar}. \\

\emph{ExiMiR} is particularly suited for two-color microarray experiments using a
common reference. In such cases the spike-in probe-based normalization method allows to
treat the raw data as if they were coming from single-channel arrays, like
Affymetrix\textsuperscript{\textregistered} Genechip\textsuperscript{\textregistered}.
This is why the objects and functions in \emph{ExiMiR} have been chosen to
closely resemble those of the ''single-color`` \emph{affy} package, while remaining
compatible with those of the ''two-color`` \emph{limma} package, as shown on
Figure \ref{fig0}.\\

The latest versions of \emph{ExiMiR} explicitly integrate the raw data objects
from the \emph{limma} package. Thus the spike-in probe-based normalization method
can be applied to raw data formats other than Exiqon or Affymetrix, as long as
suitable ''spike-in probes`` are provided.\\

\begin{figure}[t]
\begin{center}
\fbox{\includegraphics{fig0}}
\caption{Overview of the functions of the ExiMiR package (in blue).}
\label{fig0}
\end{center}
\end{figure}

Further features of \emph{ExiMiR} include:
\begin{itemize}
\item
reading raw data in the ImaGene\textsuperscript{\textregistered} TXT format
used for the Exiqon miRCURY LNA\texttrademark\ arrays;
\item
allowing to update the array probe annotations to the latest
\href{http://www.mirbase.org}{miRBase} releases incorporated in the Exiqon GAL files;
\item
enabling a background correction adapted to the raw data format by wrapping the
\emph{limma} function \verb+backgroundCorrect+;
\item
entering a user-defined set of appropriate probe IDs that can be used by the normalization
method instead of the automatically selected spike-in probes;
\item
enabling to generate the same objects for summarized miRNA expression data after
having applied the alternative normalization methods contained in both \emph{affy} and
\emph{limma} packages.

\end{itemize}

This vignette shows how to process raw expression data obtained from the
Affymetrix\textsuperscript{\textregistered} Genechip\textsuperscript{\textregistered}
miRNA array (CEL and CDF files) in order to illustrate the similarities between
\emph{ExiMiR} and \emph{affy}. An example with other raw data formats supported by
\emph{limma} is also discussed.


\section{Raw and annotation data}
\label{sec:data}

This section describes how to find raw and annotation data on which \emph{ExiMiR} can
be applied.
\nolinebreak
\footnote{N.B.: \texttt{R} objects corresponding to the raw and annotation data
described in this section are provided by the \emph{ExiMiR} package, see Section
\ref{sec:example}}
It covers both Affymetrix (CEL and CDF) and Exiqon/ImaGene (TXT and
GAL) cases. If you have your own expression data in CEL or TXT formats, then you just
need to complete them with the annotation files in CDF or GAL formats, respectively,
as described below. Do no forget the appropriate \verb+samplesinfo.txt+ file for the
Exiqon case. In case your raw data are neither in Affymetrix CEL nor in Exiqon/ImaGene
TXT formats, then first read Subsection \ref{subsec:othernorm} to see whether
\emph{ExiMiR} can be applied.


\subsection{Affymetrix}
\label{subsec:affydata}
First create a directory \verb+Affymetrix+ in your file system. The GEO repository
\linebreak(\href{http://www.ncbi.nlm.nih.gov/geo/}{http://www.ncbi.nlm.nih.gov/geo/}) contains several datasets using
the Affymetrix \mbox{miRNA-1\_0} array. We choose the series
\href{http://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE19183}{GSE19183} for which
the raw data file \verb+GSE19183_RAW.tar+ can be downloaded from this
\href{http://www.ncbi.nlm.nih.gov/geosuppl/?acc=GSE19183}{URL}.
Extract the CEL files into the \verb+Affymetrix+ directory. As long as \verb+R+ can
connect to the Bioconductor server (\href{http://www.bioconductor.org/}{http://www.bioconductor.org/}), the annotation
will be generated automatically by the \emph{affy} package when reading the CEL files
(see Subsection \ref{subsec:affynorm}). If this is not the case, you need to get and
load the package
\href{http://bioconductor.org/packages/mirna10cdf/}
{\emph{mirna10cdf}}, which will create the appropriate annotation environment for
the dataset GSE19183 in your \verb+R+ session.


\subsection{Exiqon}
\label{subsec:exidata}

First create a directory \verb+Exiqon+ in your file system. The GEO series
\href{http://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE20122}{GSE20122} contains a
suitable raw data file \verb+GSE20122_RAW.tar+ at the following
\href{http://www.ncbi.nlm.nih.gov/geosuppl/?acc=GSE20122}{URL}.
After downloading it, extract and expand (\verb+gunzip+) the enclosed raw data file in
ImaGene TXT format into the \verb+Exiqon+ directory. Then download the corresponding
annotation GAL file from the following
\href{http://shop.exiqon.com/annotations/download/gal_208200-A,208201-A,208202-A_lot31022-31022_hsa,mmu,rno-and-related-vira_from_mb160,miRPlus.gal}{URL}
into the \verb+Exiqon+ directory as well. Finally, copy and paste the content of
Appendix \ref{sec:app} of this vignette into a TAB-separated text file called
\verb+samplesinfo.txt+ and also located the \verb+Exiqon+ directory. This file is
required by \emph{ExiMiR} to match the raw data results from the Hy3 and Hy5 channels.
\footnote{In the Exiqon common reference experimental design, Hy3 and Hy5 are usually the samples
and the reference channels, respectively.}
It contains the names of all the TXT files in the experiment, organized in a table with
one row for each array and two columns corresponding to the two channels Hy3 and Hy5.
\footnote{For practical purposes only 12 of the 54 Hy3-Hy5 raw data filename
pairs from the GEO series GSE20122 are listed in Appendix \ref{sec:app}. Feel free to
complete \texttt{samplesinfo.txt} with the 42 remaining ones if you want to be
exhaustive!}
It is very similar to the file \verb+Targets.txt+ required by the \emph{limma} package
and is usually provided by Exiqon together with the raw data TXT files.


\section{Raw data normalization}
\label{sec:norm}

This section describes how to apply \emph{ExiMiR} to normalize raw miRNA
expression data obtained from the Affymetrix\textsuperscript{\textregistered} miRNA
Genechip\textsuperscript{\textregistered} or from the Exiqon miRCURY LNA\texttrademark\
arrays.
Under specific conditions, this is also possible for other raw data formats
(see Subsection \ref{subsec:othernorm}).
Notice that although these descriptions are generic, some of the
filenames given in the command-line examples might differ from case to case (e.g. GAL
filenames). Begin by launching an \verb+R+ session at the same level as the
\verb+Affymetrix+ and \verb+Exiqon+ directories created in Section \ref{sec:data}.


\subsection{Affymetrix: from CEL files to ExpressionSet objects}
\label{subsec:affynorm}

\emph{You don't need to run the following three commands if your} \verb+R+ \emph{installation can
connect the Bioconductor server} (\href{http://www.bioconductor.org/}{http://www.bioconductor.org/}).\\

The array annotation environment is created by loading the \emph{mirna10cdf} package:
\begin{Sinput}
R> library(mirna10cdf)
\end{Sinput}
Using the \verb+makecdfenv+ package, the above corresponds to the following
two commands
\begin{Sinput}
R> library(makecdfenv)
R> cdfenv <- make.cdf.env(cdf.path='Affymetrix', filename='miRNA-1_0.CDF')
\end{Sinput}
provided that the CDF file \verb+miRNA-1_0.CDF+ (formerly downloadable from the Affymetrix
website) is located in the \verb+Affymetrix+ folder.\\

Load the CEL file raw data into an AffyBatch object using the \emph{affy}
package:
\footnote{
Drop the argument \texttt{cdf.name='cdfenv'} if the environment \texttt{cdfenv} has not been
defined previously with \texttt{make.cdf.env}.
}
\begin{Sinput}
R> library(affy)
R> abatch <- ReadAffy(cdfname='cdfenv', celfile.path='Affymetrix')
\end{Sinput}
Raw data normalization is directly applied on \verb+abatch+ to create an
ExpressionSet object. For instance:
\footnote{This is equivalent to \texttt{eset.rma <- rma(abatch)}.}
\begin{Sinput}
R> eset.rma <- expresso(abatch, bgcorrect.method='rma',
                                normalize.method='quantiles',
                                pmcorrect.method='pmonly',
                                summary.method='medianpolish')
\end{Sinput}
As an alternative to the above RMA quantile normalization validated for gene (mRNA)
expression \cite{RMA}, the spike-in probe-based method implemented in the \emph{ExiMiR} function
\verb+NormiR+ might give better results for miRNA expression data \cite{bibi,sarkar}:

\begin{Sinput}
R> library(ExiMiR)
R> eset.spike <- NormiR(abatch, bgcorrect.method='rma',
                                normalize.method='spikein',
                                pmcorrect.method='pmonly',
                                summary.method='medianpolish')
\end{Sinput}
For the GSE19183 dataset, the assumptions allowing the application of the \verb+NormiR+
spike-in probe-based normalization are not satisfied and a default median normalization
is performed instead. Section \ref{sec:trouble} describes this safeguarding strategy
and the options allowing to deal with problematic cases. If the \verb+NormiR+
assumptions are satisfied, a series of control figures are generated. Their
description is given in Section \ref{subsec:figs} below.


\subsection{Exiqon: from TXT files to ExpressionSet objects}
\label{subsec:exinorm}


First load the \emph{ExiMiR} package:

\begin{Sinput}
R> library(ExiMiR)
\end{Sinput}
Then create the array annotation environment using the GAL file and the
\verb+make.gal.env+ function:

\begin{Sinput}
R>  make.gal.env(galname='galenv', gal.path='Exiqon')
\end{Sinput}
Read the raw data TXT files into an AffyBatch object using the \verb+ReadExi+ function:
\footnote{
\texttt{ReadExi} stores the dual-channel foreground and background intensity data as follows:
the foreground data matrix of the Hy3 channel (second column of \texttt{samplesinfo.txt})
and the foreground data matrix of the Hy5 channel (third column of \texttt{samplesinfo.txt})
are concatenated and stored in the \texttt{exprs} slot of the resulting AffyBatch object.
The same goes for the background data in the \texttt{se.exprs} slot.\label{footnote:readexi}
}

\begin{Sinput}
R> ebatch <- ReadExi(galname='galenv', txtfile.path='Exiqon')
\end{Sinput}
Similarly to the Affymetrix case in Subsection \ref{subsec:affynorm}, the raw data
normalization is applied on \verb+ebatch+ to create an ExpressionSet object. For
instance the RMA quantile normalization from the \emph{affy} package \cite{RMA}, using the option \verb+bg.correct=FALSE+, as recommended by a recent study\cite{lopez}:
\footnote{This command is not equivalent to \texttt{eset.rma <- rma(ebatch,background=FALSE)}
because \texttt{NormiR} applies the quantile normalization separately on the data
from the Hy3 and Hy5 channels (which have been concatenated in \texttt{ebatch} by
\texttt{ReadExi}) while \texttt{rma} mixes the data from two channels.\label{footnote:rma}
}
\begin{Sinput}
R> eset.rma <- NormiR(ebatch, bg.correct=FALSE,
                              normalize.method='quantile',
                              summary.method='medianpolish')
\end{Sinput}
However, the assumptions for applying the quantile normalization are not guaranteed to be satisfied in
the case of miRNA expression data \cite{bibi, sarkar}. It might be better to use
the spike-in probe-based method from \emph{ExiMiR}:

\begin{Sinput}
R> eset.spike <- NormiR(ebatch, bg.correct=FALSE,
                                normalize.method='spikein',
                                summary.method='medianpolish')
\end{Sinput}
If all the assumptions underlying the application of the \verb+NormiR+ spike-in probe-based
normalization are satisfied, a series of control figures are generated, which will be
explained in Subsection \ref{subsec:figs}. If one or more assumptions are not met,
then the median normalization is applied instead. However, \emph{ExiMiR} offers several
options to deal with such situations and still allow the application of the spike-in
probe-based method, as explained in Subsections \ref{subsec:problems} and
\ref{subsec:opt}.


\subsection{Other formats: reading with \emph{limma} and normalizing with \emph{ExiMiR}}
\label{subsec:othernorm}

The approach consists in reading the raw data using the \emph{limma} package and then
transforming the result into an AffyBatch object using the function \verb+creatAB+, as
illustrated on Figure \ref{fig0}. Therefore the
conditions for applying \emph{ExiMiR} on other raw data forms are
(1) the ability to load the raw data into \emph{limma} objects (EList or RGList), and
(2) the availability of probe sets that can be used as ''spike-in probes`` during
normalization. The parameter \verb+probeset.list+ of the function \verb+NormiR+ allows to
select the IDs of such ''spike-in probes`` for running the normalization method, as long
as they satisfy its underlying assumptions (see Subsections \ref{subsec:figs} and
\ref{subsec:opt}).\\

As a toy example, this approach is applied on the Exiqon raw data from Subsection
\ref{subsec:exinorm}, which satisfy the two conditions discussed above. You will need to
set the parameters of the function \verb+read.maimage+ according to your
particular case (see Chapter 4 of the
\href{www.bioconductor.org/packages/release/bioc/vignettes/limma/inst/doc/usersguide.pdf}{
\emph{limma} User's Guide} for more details).\\

First create the \verb+Targets.txt+ file in the \verb+Exiqon+ directory. In our case
this consists simply in replacing the header line of the file \verb+samplesinfo.txt+ by
''\verb+FileName+\hspace{0.5 cm}\verb+Cy3+\hspace{0.5 cm}\verb+Cy5+``
(TAB-separated) and saving the result as \verb+Targets.txt+. Then proceed by
reading the raw data and annotating the probe sets using the available GAL file:
\begin{Sinput}
R> library(limma)
R> targets <- readTargets(path='Exiqon')
R> RGList <- read.maimages(targets[,c('Cy3','Cy5')], source='imagene', path='Exiqon')
R> RGList$genes <- readGAL(path='Exiqon')
R> RGList$printer <- getLayout(RGList$genes)	# optional
\end{Sinput}
The last line enables plotting the spatial distributions of the intensities of the arrays
using the \verb+image+ method of the AffyBatch object created below. Running
\verb+getLayout+ is not always possible (see Section 4.7 of of the
\href{www.bioconductor.org/packages/release/bioc/vignettes/limma/inst/doc/usersguide.pdf}
{\emph{limma} User's Guide}) and not needed for the spike-in probe-based normalization.
The AffyBatch object is created using the function \verb+createAB+ of the \emph{ExiMiR}
package:
\footnote{
\texttt{createAB} stores dual-channel foreground and background intensity data in the same
way as \texttt{ReadExi}, see footenote \ref{footnote:readexi} in Subsection \ref{subsec:exinorm}.
}
\begin{Sinput}
R> library(ExiMiR)
R> obatch <- createAB(RGList)
\end{Sinput}
Next the ''spike-in probes`` used for normalization must be specified. In our toy example
they will consist in a subset of the available annotated spike-in probe sets, excluding
\verb+spike_control_f+. Other choices are possible, as long as \verb+NormiR+
can be run (see Subsections \ref{subsec:figs} and \ref{subsec:opt}). The raw
data normalization is then performed similarly as above (see Subsection
\ref{subsec:exinorm}):
\begin{Sinput}
R> spikein.all <- grep('^spike', featureNames(obatch), value=TRUE)
R> spikein.subset <- setdiff(spikein.all, 'spike_control_f')
R> eset.spike <- NormiR(obatch, bg.correct=FALSE,
                                normalize.method='spikein',
                                normalize.param=list(probeset.list=spikein.subset),
                                summary.method='medianpolish')
\end{Sinput}
The comments made after the execution of \verb+NormiR+ at the end of the
previous subsection remain valid in the present case.


\subsection{More information about \texttt{NormiR}}
\label{subsec:normir}

\emph{This paragraph provides additional information about the \texttt{NormiR} function
and can be skipped on first reading.}\\

The function \verb+NormiR+ has been designed to closely resemble the \verb+expresso+
function of the \emph{affy} package. Therefore their usages are very similar
(see Section 3.3.1 of the \emph{affy}
\href{http://www.bioconductor.org/packages/release/bioc/vignettes/affy/inst/doc/affy.pdf}
{vignette}):
\begin{Sinput}
ESet <- NormiR(AffyBatch,
             # background correction
               bg.correct=TRUE,
               bgcorrect.method='auto',
               bgcorrect.param=list(),
             # normalization
               normalize=TRUE,
               normalize.method='spikein',
               normalize.param=list(),
             # PM correction (enabled only when MM-values are available)
               pmcorrect.method='pmonly',
               pmcorrect.param=list(),
             # summarization
               summary.method='medianpolish',
               summary.param=list(),
             # miscellaneous
               verbose=TRUE
               ...)
\end{Sinput}
The methods proposed by \verb+NormiR+ for the first step of background
correction are provided by the \emph{affy} or \emph{limma} packages,
depending on whether the input AffyBatch object has been created with
\verb+ReadAffy+ or \verb+ReadExi+/\verb+createAB+, respectively. The
\emph{ExiMiR} function \verb+NormiR.bgcorrect.methods+ lists the
available methods, as for instance in the case of the AffyBatch
objects defined in Subsections \ref{subsec:affynorm} and
\ref{subsec:exinorm}:
\begin{Sinput}
R> NormiR.bgcorrect.methods(abatch)
[1] "bg.correct"	"mas"	"none"	"rma"
R> NormiR.bgcorrect.methods(ebatch)
[1] "edwards"	"half"	"minimum"	"movingmin" "none" "normexp" ...
\end{Sinput}
The \emph{limma} background correction methods requiring background intensity
values are provided the suitable input data, automatically extracted from the
AffyBatch object previously created with \verb+ReadExi+/\verb+creatAB+.
\footnote{
The way \texttt{ReadExi} and \texttt{creatAB} store dual-channel foreground
and background intensity data in an AffyBatch object has been described above,
see Footnote \ref{footnote:readexi}.
}
Therefore, applying for instance the \verb+normexp+ background correction on the
\verb+ebatch+ AffyBatch object is straightforward with \verb+NormiR+:
\begin{Sinput}
R> eset.spike <- NormiR(ebatch, bgcorrect.method='normexp'
			        bgcorrect.param=list(offset=50),
			        normalize.method='spikein',
                                summary.method='medianpolish')
\end{Sinput}
For the next step of normalization, the methods are independent of the
AffyBatch objects and explicitly enumerated by the \emph{ExiMiR} function
\verb+NormiR.normalize.methods+:
\begin{Sinput}
R> NormiR.normalize.methods()
[1] "mean"	"median"	"none"	"quantile"	"spikein"
\end{Sinput}
As explained above (see Footnote \ref{footnote:rma}), the quantile
normalization \verb+quantile+ treats separately the two channels
in case of dual-channel raw data processed by \verb+ReadExi+ or
\verb+creatAB+. When the spike-in probe-based normalization \verb+spikein+
is chosen, \verb+NormiR+ automatically detects the spike-in probes,
based on the Affymetrix or Exiqon annotations. If this detection is not
successful or if you want to use your own selection of ''spike-in probes``,
the parameter \verb+probeset.list+
in \verb+NormiR+ allows to enter the appropriate list of probe set IDs
(see also Subsection \ref{subsec:opt}). More generally, all the \verb+NormiR+
parameters enabling fine-tuning of the spike-in probe-based
normalization \verb+spikein+ are provided as a list with their default
values by the function \verb+NormiR.spikein.params+. You can modify this
list and submit it to \verb+NormiR+ using the parameter
\verb+normalize.param+.
\footnote{
Due to compatibility constraints with older versions of \texttt{NormiR},
the normalization parameters provided by \texttt{NormiR.spikein.params}
are also adjustable as explicit \texttt{NormiR} arguments, for instance
\texttt{NormiR(ebatch, normalize.method='spikein', normalize.param=list(figures.show=FALSE))}
is equivalent to
\texttt{NormiR(ebatch, method='spikein', figures.show=FALSE)}.
}
This constitutes the starting point for controlling the execution of \verb+NormiR+
(see Section \ref{sec:trouble} for details). For instance, using the subset
of spike-in probes \verb+spikein.subset+ defined in
Subsection \ref{subsec:othernorm}:
\begin{Sinput}
R> NormiR.spikein.params()
R> spikein.params <- list(probeset.list=spikein.subset,
			  loess.span=0.6,
			  force.zero=TRUE)
R> eset.spike <- NormiR(ebatch, bgcorrect.method='normexp'
			        bgcorrect.param=list(offset=50),
			        normalize.method='spikein',
			        normalize.param=spikein.params,
                                summary.method='medianpolish')
\end{Sinput}
The next step of PM correction is enabled only when the CDF environment
provides values for the MM probes in the AffyBatch object, which is not
the case of the Exiqon data considered here.\\
The last step is the probe summarization, for which \verb+NormiR+
proposes the methods of the \emph{affy} package:
\begin{Sinput}
R> NormiR.summary.methods()
[1] "avgdiff"	"liwong"	"mas"	"medianpolish"	"playerout"
\end{Sinput}
Actually, \verb+NormiR+ is a wrapper for three lower-level
functions, which all accept the corresponding \verb+NormiR+
parameters. Therefore the previous \verb+NormiR+ command is
equivalent to:
\begin{Sinput}
R> ebatch.tmp <- bg.correct.miR(ebatch, bgcorrect.method='normexp',
    			                bgcorrect.param=list(offset=50))
R> ebatch.tmp <- norm.miR(ebatch.tmp, normalize.method='spikein',
			              normalize.param=spikein.params)
R> eset.spike <- summarize.miR(ebatch.tmp, summary.method='medianpolish')
\end{Sinput}
Separating the normalization steps allows to more efficiently search
the most appropriate parameters for the spike-in probe-based
normalization without running the time-consumming summarization step
at every attempt (see Section \ref{sec:trouble} for details).\\

The low-level summary function \verb+summarize.miR+ can also be run in
combination with \verb+createAB+ in order to summarize a MAList object
obtained with a normalization method of the \emph{limma} package
(see Figure \ref{fig0}). For instance, using the RGList object defined in
Subsection \ref{subsec:othernorm}:
\begin{Sinput}
R> MAList.tmp <- normalizeWithinArrays(RGList, method='loess')
R> MAList <- normalizeBetweenArrays(MAList.tmp, method='Rquantile')
R> obatch <- createAB(MAList)
R> oset.rrma <- summarize.miR(obatch, summary.method='medianpolish')
\end{Sinput}


\section{Troubleshooting and fine-tuning options}
\label{sec:trouble}

\emph{ExiMiR} provides several functionalities to ensure a safe application of the
spike-in probe-based normalization. This section first describes the control figures
generated during the execution of the \verb+NormiR+ function (Subsection
\ref{subsec:figs}). They allow to identify the problems that may arise when applying
\emph{ExiMiR}. Subsection \ref{subsec:problems} will help understanding their origin
and deciding whether to still use \emph{ExiMiR} (with different parameters) or to
switch to another method like median normalization. The fine-tuning options offered
by \emph{ExiMiR} are explained in Subsection \ref{subsec:opt}.


\subsection{Control figures}
\label{subsec:figs}

In order to follow the execution of the spike-in probe-based normalization implemented
in \texttt{NormiR}, a series of three control figures are generated for each channel of
the input data. They allow to confirm the successful application of the normalization
method but also to detect possible anomalies, that can be then treated with the options
described in Subsection \ref{subsec:opt}. This feature runs by default and can be
deactivated by setting  \verb+figures.show=FALSE+ in \verb+NormiR+.\\

The three control figures generated for the Hy3 channel of the Exiqon example from
Subsections \ref{subsec:exidata} and \ref{subsec:exinorm} are briefly described
hereafter. For more details see \cite{bibi}.

\begin{figure}[t]
\begin{center}
\fbox{\includegraphics{fig1}}
\caption{Correction of the spike-in probe set intensities (Hy3 channel)}
\label{fig1}
\end{center}
\end{figure}


\begin{description}

\item[Correction of the spike-in probe set intensities] The four panels in Figure
\ref{fig1} show the successive steps in removing the array-dependent biases from the
spike-in probe set intensities. A meaningful application of \verb+NormiR+ indeed
requires that the spike-in probe set intensities display coherent deviations across the
arrays of the experiment. Such a behavior manifests itself by roughly parallel curves
on the upper-left panel and by collapsing ones on the upper-right panel. The
normalization correction consists first in subtracting this common variance (lower-left
panel) and second in transforming back to the original intensity range (lower-right
panel). Correcting the curves is proved efficient when the final ones appear
'straighter' than the initial ones.

\begin{figure}[t]
\begin{center}
\fbox{\includegraphics{fig2}}
\caption{Performance of the spike-in probe set intensity correction (Hy3 channel)}
\label{fig2}
\end{center}
\end{figure}

\item[Performance of the spike-in probe set intensity correction] Figure \ref{fig2}
contains two measures for quantitatively assessing the performance of the spike-in
probe set intensity correction used by \verb+NormiR+. The upper panel shows a heatmap
of the Pearson correlations between the array-dependent raw intensities of the spike-in
probe sets, i.e. between the curves displayed on the upper-left panel of Figure
\ref{fig1}. If the values are globally larger than 0.5, then the array-dependent biases
are sufficiently coherent and applying \verb+NormiR+ is justified. The lower panel
displays the variance ratio of the spike-in probe sets intensities before and after the
correction. They correspond to the curves in the upper-left and lower-right panels of
Figure \ref{fig1}. If these ratios are sufficiently low, then the \verb+NormiR+
approach was effective.

\begin{figure}[t]
\begin{center}
\fbox{\includegraphics{fig3}}
\caption{Intensity-dependent correction functions (Hy3 channel)}
\label{fig3}
\end{center}
\end{figure}

\item[Intensity-dependent correction functions for all probes] Figure \ref{fig3}
displays the intensity and array dependent correction functions that \verb+NormiR+
applies to all miRNA probes to perform the normalization. It is constructed based on the
spike-in probe corrections, already shown on Figures \ref{fig1} and \ref{fig2}. Several
requirements are necessary to ensure a stable coverage of the whole range of probe
intensities measured on the array. \emph{ExiMiR} automatically performs checks to
prevent critical situations where its meaningful application is not guaranteed.
Sometimes the constructed correction functions do not look good, even if \verb+NormiR+
ran smoothly. Dealing with such situations is also described in Section
\ref{subsec:opt} below.

\end{description}


\subsection{Possible problems}
\label{subsec:problems}

The application of \emph{ExiMiR} fundamentally assumes that the spike-in probes capture
the greatest part of the between-array technical variability in the miRNA expression data. This
is normally the case when the processing of the RNA samples prior to the addition of
the spike-in RNAs is suitably standardized and controlled. If this condition is
satisfied, then \emph{ExiMiR} requires three features from the spike-in control probes
to be meaningfully applied, see \cite{bibi}. These features are automatically tested by
the software. In case of failure, median normalization is used instead of spike-in
probe-based method. However the threshold values used in these tests can be changed to
force the application of the spike-in probe-based method. Its consequences can then be
investigated on the control figures described in Subsection \ref{subsec:figs} to decide
whether the application of \emph{ExiMiR} was justified or not. Other problems like
annotation conflicts are also supported by \emph{ExiMiR}. \\

Here is the list of the problematic situations covered by \emph{ExiMiR}, arranged by
potential order of appearance.

\begin{description} \item[Incompatibility between GAL and TXT files] If the array
annotation contained in the GAL file is not compatible with the one contained in the
TXT files, or if there is no GAL file available, then \verb+ReadExi+ directly generates
a default \verb+galenv+ environment from the annotation contained in the TXT files.

\item[Insufficient coherence between spike-in probe sets] If the raw intensities of the
spike-in probe sets are not sufficiently coherent across the arrays of the experiment,
i.e. if the mean of the off-diagonal elements of the Pearson correlation matrix shown
on the upper panel of Figure \ref{fig2} is smaller than 0.5, then a median
normalization is applied. The value can be changed by using the \verb+min.corr+ of
\verb+NormiR+.

\item[Specificity of the spike-in probeset intensities] If the spike-in probeset
intensities are not specific, i.e. if the intensity ranges covered by the probes
mapping to the same probe sets are too large, then computing the intensity-dependent
correction functions from Figure \ref{fig3} becomes problematic. The
intensity-independent median normalization is preferred in this case. The \verb+NormiR+
parameter \verb+max.log2span+ can be changed to allow for probeset intensity ranges larger
than the default value 1.

\item[Insufficient coverage of the probe intensity range] If the range
[$\sim$6,$\sim$16] of all array probe intensities is not appropriately covered by the
spike-in probe intensities, then computing the intensity dependence of the correction
functions from Figure \ref{fig3} becomes unstable. The \verb+NormiR+ parameter
\verb+cover.int+ tests the size of the largest intensity interval between two
consecutive spikes. Its default value is 1/3. The \verb+NormiR+ parameter
\verb+cover.ext+ tests the minimal ratio between the intensity range covered by the
spike-in probes and the one covered by all probes on the array. Its default value is
1/2. These two values can be changed but an eye must be kept on their consequences on
the correction functions from Figure \ref{fig3}, since the latter are not explicitly
tested by \emph{ExiMiR}. The \verb+NormiR+ options for computing these correction
functions are explained in Subsection \ref{subsec:opt} below.

\end{description}

\subsection{\emph{NormiR} options for computing the correction functions}
\label{subsec:opt}

The results for the spike-in probe-based correction functions displayed on Figure
\ref{fig3} are not tested automatically by \emph{ExiMiR} and might not be entirely
satisfactory. This might be due to multiple reasons, ranging from inhomogeneous
affinities across the spike-in probe sets to an inappropriate coverage of the probe
intensity range. \emph{ExiMiR} offers the possibility of fine-tuning the
parameters used by \verb+NormiR+ to improve the stability of the correction
functions (see also Subsection \ref{subsec:normir} for command line examples).

\begin{description}

\item[Selection of the spike-in probes] If the control figures show that only a
subset of the spike-in probe sets displays the appropriate behavior, it can be
manually selected for the calculation of the correction functions. Set the
\verb+NormiR+ parameter \verb+probeset.list+ to the list of the appropriate
spike-in probe sets IDs.
\footnote{
Actually \texttt{probeset.list} allows to select any set of probe set IDs and
tentatively run \texttt{NormiR}. However, the safeguarding strategy implemented
in \texttt{NormiR} prevents inappropriate choices of ''spike-in probes``.
}

\item[Overall LOESS smoothing] If the correction functions 'wiggle' too much, the
\verb+NormiR+ parameter \verb+loess.span+ can be set to higher values to better smooth the
resulting curves. By default, it takes the value 5/(number of spike-in probe sets), e.g.
5/10 in the Exiqon case. In the extreme cases of values close to 1, the intensity
dependence of the correction is lost and the results become very similar to a mean or a
median normalization.

\item[Low-intensity stabilization] If one correction function change its sign in the
low intensity range, then an inclusion into the LOESS smoothing of a zero value at the
intensity minimum will prevent this feature. Set the \verb+NormiR+ parameter
\verb+force.zero+ to \verb+TRUE+  to activate this functionality.

\item[High-intensity extrapolation] It often occurs that the largest spike-in probeset
intensities are lower than the largest probe intensities on the array. In this case
\verb+NormiR+ needs to include extrapolated values into the LOESS smoothing in order to
compute the correction functions in the high-intensity range. Fortunately this step is
quite stable thanks to the fact that high intensity values are less noisy. By default
\verb+NormiR+ uses the mean of the correction values of two spike-in probe sets with the
largest intensities. The parameter \verb+extrap.points+ allows to change the number of
spike-in probe sets used in the extrapolation and \verb+extrap.method+ determines the
extrapolation method.

\end{description}

\section{Concrete example with provided data}
\label{sec:example}
\emph{ExiMiR} provides datasets that allows one to test the functions described in this vignette. The test data are in the \verb+R+ objects obtained as
described in Section \ref{sec:data}. They can be used as follows,  which reproduces the commands explained in Section \ref{sec:norm}.

\subsection{Affymetrix}
Start by loading the \emph{ExiMiR} package and the AffyBatch object, which includes the appropriate annotation environment and corresponds to the data described in Section \ref{subsec:affydata}:
<<>>=
library(ExiMiR)
data(GSE19183)
@
Apply the RMA quantile normalization on the AffyBatch object \verb+GSE19183+ to create the ExpressionSet object \verb+eset.rma+ containing the normalized data:
<<>>=
library(affy)
eset.rma <- expresso(GSE19183, bgcorrect.method='rma',
			       normalize.method='quantiles',
			       pmcorrect.method='pmonly',
			       summary.method='medianpolish')

@
The spike-in probe-based normalization implemented in \emph{ExiMiR} can be applied similarly:
<<>>=
eset.spike <- NormiR(GSE19183, bgcorrect.method='rma',
			       normalize.method='spikein',
			       normalize.param=list(figures.show=FALSE),
			       pmcorrect.method='pmonly',
			       summary.method='medianpolish')
@
As explained at the end of Section \ref{subsec:affynorm}, the spike-in probe-based normalization method implemented in \verb+NormiR+ can not be applied with its default settings.
Use the \verb+figures.show=TRUE+ option to diagnose graphically the problem (see Section \ref{subsec:figs}). The safeguarding strategies are described in Section \ref{subsec:problems}
and the \verb+NormiR+ options described in Section \ref{subsec:opt}. Here \verb+NormiR+ cannot be
satisfactorily applied to \verb+GSE19183+ because the spike-in probe intensities do not appropriately cover the intensity range of all the array probes.


\subsection{Exiqon}
Load the \emph{ExiMiR} package, the GAL annotation environment and the AffyBatch objects corresponding to the data described in Section \ref{subsec:exidata}:
<<>>=
library(ExiMiR)
data(galenv)
data(GSE20122)
@
Apply the RMA quantile normalization on the AffyBatch object \verb+GSE20122+, using the \verb+rma+ option \verb+background=FALSE+ as recommended by a recent study\cite{lopez}.
This creates the ExpressionSet object \verb+eset.rma+ containing the normalized data:
<<>>=
eset.rma <- NormiR(GSE20122, bg.correct=FALSE,
			     normalize.method='quantile',
			     summary.method='medianpolish')
@
The spike-in probe-based normalization implemented in \emph{ExiMiR} is applied as follows:
<<>>=
eset.spike <- NormiR(GSE20122, bg.correct=FALSE,
			       normalize.method='spikein',
			       normalize.param=list(figures.show=FALSE),
			       summary.method='medianpolish')
@
To obtain the same control figures as the ones displayed in Section \ref{subsec:figs}, use the \verb+NormiR+ option \verb+figures.show=TRUE+.

\newpage
\begin{thebibliography}{2}

\bibitem{bibi}
Sewer A et \textit{al}., to be published.

\bibitem{sarkar}
Sarkar D et \textit{al}., Quality assessment and data analysis for miRNA expression
arrays, Nucleic Acids Research 2009, \textbf{37}(2).

\bibitem{RMA}
Irizarry RA et \textit{al}., Biostatistics 2003, \textbf{4}(2).

\bibitem{lopez}
L\'{o}pez-Romero P et \textit{al}., Procession of Agilent microRNA array data,
BMC Research Notes 2010, \textbf{3}:18.


\end{thebibliography}



\newpage
\appendix{}
\section{Content of the file ''samplesinfo.txt''}
\label{sec:app}
\scriptsize{
\begin{Sinput}
Names	Hy3	Hy5
1	GSM503402_Hy3_Exiqon_14114402_S01_Cropped.txt	GSM503402_Hy5_Exiqon_14114402_S01_Cropped.txt
2	GSM503403_Hy3_Exiqon_14114403_S01_Cropped.txt	GSM503403_Hy5_Exiqon_14114403_S01_Cropped.txt
3	GSM503404_Hy3_Exiqon_14114404_S01_Cropped.txt	GSM503404_Hy5_Exiqon_14114404_S01_Cropped.txt
4	GSM503405_Hy3_Exiqon_14114405_S01_Cropped.txt	GSM503405_Hy5_Exiqon_14114405_S01_Cropped.txt
5	GSM503406_Hy3_Exiqon_14114406_S01_Cropped.txt	GSM503406_Hy5_Exiqon_14114406_S01_Cropped.txt
6	GSM503407_Hy3_Exiqon_14114407_S01_Cropped.txt	GSM503407_Hy5_Exiqon_14114407_S01_Cropped.txt
7	GSM503408_Hy3_Exiqon_14114408_S01_Cropped.txt	GSM503408_Hy5_Exiqon_14114408_S01_Cropped.txt
8	GSM503409_Hy3_Exiqon_14114409_S01_Cropped.txt	GSM503409_Hy5_Exiqon_14114409_S01_Cropped.txt
9	GSM503410_Hy3_Exiqon_14114410_S01_Cropped.txt	GSM503410_Hy5_Exiqon_14114410_S01_Cropped.txt
10	GSM503411_Hy3_Exiqon_14114411_S01_Cropped.txt	GSM503411_Hy5_Exiqon_14114411_S01_Cropped.txt
11	GSM503412_Hy3_Exiqon_14114412_S01_Cropped.txt	GSM503412_Hy5_Exiqon_14114412_S01_Cropped.txt
12	GSM503413_Hy3_Exiqon_14114413_S01_Cropped.txt	GSM503413_Hy5_Exiqon_14114413_S01_Cropped.txt
\end{Sinput}
}

\end{document}

\name{norm.miR}
\alias{norm.miR}

\title{
ExiMiR low-level function for miRNA raw data normalization.
}

\description{
This function performs low-level normalization on an \code{AffyBatch} object
and returns the result in a new \code{AffyBatch} object.

By default, it applies the spike-in probe-based normalization method. In case the
spike-in probe-based method cannot be applied, a median normalization is executed
instead. Several options allow however to force the execution of the spike-in probe-based
normalization and to fine-tune the resulting correction functions.	
}

\usage{
norm.miR(abatch,
         normalize.method="spikein",
         normalize.param=list(),
         verbose=TRUE,
	 ...)
}

\arguments{
\item{abatch}{
	An \code{AffyBatch} object.
}
\item{normalize.method}{
	Character vector. It contains the name of normalization method. By default, the
	\code{spikein} method is used. Running \code{NormiR.normalize.methods(abatch)} indicates
	which other methods can be chosen, depending on the raw data contained in the
	\code{abatch} object.
}
\item{normalize.param}{
	A \code{R} list of the arguments that are used to control the \code{spikein} normalization. Running
        \code{NormiR.spikein.args()} provides a complete list of all the tunable parameters supported by
	\code{norm.miR} and explained below.
	\describe{
	\item{figures.output}{
		Character vector. By default, \code{display} is used. Figures are shown to the screen. Using \code{file}
		generates the figures in PDF format in the working directory.
	}
	\item{min.corr}{
		Numeric. Default value is 0.5. Minimal allowed value for the average of the off-diagonal elements of the
		Pearson correlation matrix of the spike-in probeset intensities across the arrays.
	}
	\item{loess.span}{
		Numeric. Default value is -1, which corresponds to a loess smoothing neighbourhood spanning a fraction
		3/(number of spike-in probesets) of the total number of points. Other positive values are allowed, see
		the \code{span} argument of the R \code{loess} function
	}
	\item{extrap.points}{
		Numeric. Default value is 2. The number of spike-in probesets used in the high-intensity extrapolation of
		the normalization correction function.
	}
	\item{extrap.method}{
		Character vector. Default value is \code{mean}. The method used for the high-intensity extrapolation of
		the normalization correction function.
	}
	\item{force.zero}{
		Logical. Default value is \code{FALSE}. If \code{TRUE}, it forces the normalization correction functions to
		have zero values at the lower end of the probe intensity range.
	}
	\item{cover.ext}{
		Numeric. Default value is 1/2. Minimal allowed relative coverage of the spike-in probesets intensities. It
		is computed as the ratio between the intensity range covered by the spike-in probes and the one covered by
		all probes on the array.
	}
	\item{cover.int}{
		Numeric. Default value is 1/3. Maximal allowed relative intensity interval between two consecutive
		spike-in probesets. It is computed as the largest intensity difference between two consecutive spike-in
		probesets divided by the overall probe intensity range.
	}
	\item{verbose}{
		Logical. Default is \code{TRUE}; some details are provided on the console.
	}
	\item{max.log2span}{
		Numeric. Default value is 1. Gives the maximal (log2) intensity interval allowed for the probes belonging
		to one spike-in probeset.
	}
	\item{probeset.list}{
		Vector of probes names that will be used as the "spike-in probes". By default, \code{norm.miR} uses the
		probes annotated as "spike-in" by Exiqon or Affymetrix.
	}
	}
}
\item{verbose}{
	Logical. The default value is \code{TRUE}. The details of the function execution are displayed on the console.
}
\item{...}{
	Any additional argument. Used for backward compatibility.
}
}

\details{
See accompanying vignette.  
}

\value{
An \code{AffyBatch} object containing the normalized (but not summarized) expression data.
}

\examples{
data(galenv)
data(GSE20122)
GSE20122.normalized <- norm.miR(GSE20122,
                                normalize.param=list(figures.show=FALSE)) 
# Apply the affy method hist on the generated AffyBatch object GSE20122.normalized
layout(matrix(c(1,2), 1, 2, byrow = TRUE))
hist(GSE20122)
hist(GSE20122.normalized)
layout(1)
}

\author{
Sylvain.Gubian, Alain.Sewer, PMP SA
}

\seealso{
\code{NormiR.normalize.methods},
\code{NormiR.spikein.args},
\code{NormiR}.
}

\name{NormiR}
\alias{NormiR}

\title{
ExiMiR high-level function for miRNA raw data normalization.
}

\description{
This function applies a standard raw data normalization pipeline (i.e. background
correction, normalization, PM correction if needed, and summarization) on the
input \code{AffyBatch} object and returns the result in an \code{ExpressionSet} object. 

The methods supported by \code{NormiR} for the background correction are provided by
the \code{affy} or \code{limma} packages, depending on whether the input \code{AffyBatch}
object has been created with \code{ReadAffy} or \code{ReadExi}/\code{createAB},
respectively.

By default, it applies the spike-in probe-based method for the second step of
normalization. In case the spike-in probe-based method cannot be applied, a median
normalization is executed instead. Several options allow however to force the execution
of the spike-in probe-based normalization and to fine-tune the resulting correction
functions.

The next step of PM correction is enabled only when numerical values are available
for the MM probes of the input \code{AffyBatch} object. In this case the methods proposed
by \code{NormiR} are provided by the \code{affy} package.

The methods supported by \code{NormiR} for the last step of summarization are also
provided by the \code{affy} package. They do not depend on how the input \code{AffyBatch}
object has been created.
}

\usage{
NormiR(abatch,
       # background correction
       bg.correct=TRUE,
       bgcorrect.method='auto',
       bgcorrect.param=list(),
       # normalize
       normalize=TRUE,
       normalize.method='spikein',
       normalize.param=list(),
       # pm correction (enabled only when MM-values are available)
       pmcorrect.method='pmonly',
       pmcorrect.param=list(),
       # expression values
       summary.method='medianpolish',
       summary.param=list(),
       summary.subset=NULL,
       # misc.
       verbose=FALSE,
       ...)
}

\arguments{
\item{abatch}{
	An \code{AffyBatch} object.
}
\item{bg.correct}{
	Logical. Default is \code{TRUE}: the background correction step will be performed. 
}
\item{bgcorrect.method}{
	Character vector. It contains the name of the background correction method. Running
	\code{NormiR.bgcorrect.methods(abatch)} indicates which methods can be used, depending
        on the raw data contained in the \code{abatch} object. The \code{auto} option
	corresponds to the default choice of applying \code{rma} for single-channel arrays
	and \code{normexp} for dual-channel arrays.
}
\item{bgcorrect.param}{
	A \code{R} list containing the parameters required by the selected background correction method,
	as specified in the documentation of the original functions \code{bg.correct} of the
	\code{affy} package or \code{backgroundCorrect} of the \code{limma} package. As an illustration
	the parameters of the \code{normexp} method of the \code{limma} package are given below.
	\describe{
	\item{normexp.method}{
		Character vector. The variant of the \code{normexp} method, matching exactly
		the argument \code{normexp.method} of the \code{backgroundCorrect} function. 
	}
	\item{offset}{
		Numeric value to add to intensities. It matches exactly the argument
 		\code{offset} of the \code{backgroundCorrect} function. 
	}
	}
}
\item{normalize}{
	Logical. Default is \code{TRUE}: the normalization step will be performed. 
}
\item{normalize.method}{
	Character vector. It contains the name of normalization method. By default, the
	\code{spikein} method is used. Running \code{NormiR.normalize.methods(abatch)} indicates
	which other methods can be chosen, depending on the raw data contained in the
	\code{abatch} object.
}		
\item{normalize.param}{
	A \code{R} list of the arguments that are used to control the \code{spikein} normalization. Running
        \code{NormiR.spikein.args()} provides a complete list of all the tunable parameters supported by
	\code{NormiR} and explained below.
	\describe{
	\item{figures.output}{
		Character vector. By default, \code{display} is used. Figures are shown to the screen. Using \code{file}
		generates the figures in PDF format in the working directory.
	}
	\item{min.corr}{
		Numeric. Default value is 0.5. Minimal allowed value for the average of the off-diagonal elements of the
		Pearson correlation matrix of the spike-in probeset intensities across the arrays.
	}
	\item{loess.span}{
		Numeric. Default value is -1, which corresponds to a loess smoothing neighbourhood spanning a fraction
		3/(number of spike-in probesets) of the total number of points. Other positive values are allowed, see
		the \code{span} argument of the R \code{loess} function
	}
	\item{extrap.points}{
		Numeric. Default value is 2. The number of spike-in probesets used in the high-intensity extrapolation of
		the normalization correction function.
	}
	\item{extrap.method}{
		Character vector. Default value is \code{mean}. The method used for the high-intensity extrapolation of
		the normalization correction function.
	}
	\item{force.zero}{
		Logical. Default value is \code{FALSE}. If \code{TRUE}, it forces the normalization correction functions to
		have zero values at the lower end of the probe intensity range.
	}
	\item{cover.ext}{
		Numeric. Default value is 1/2. Minimal allowed relative coverage of the spike-in probesets intensities. It
		is computed as the ratio between the intensity range covered by the spike-in probes and the one covered by
		all probes on the array.
	}
	\item{cover.int}{
		Numeric. Default value is 1/3. Maximal allowed relative intensity interval between two consecutive
		spike-in probesets. It is computed as the largest intensity difference between two consecutive spike-in
		probesets divided by the overall probe intensity range.
	}
	\item{verbose}{
		Logical. Default is \code{TRUE}; some details are provided on the console.
	}
	\item{max.log2span}{
		Numeric. Default value is 1. Gives the maximal (log2) intensity interval allowed for the probes belonging
		to one spike-in probeset.
	}
	\item{probeset.list}{
		Vector of probes names that will be used as the "spike-in probes". By default, \code{NormiR} uses the
		probes annotated as "spike-in" by Exiqon or Affymetrix.
	}
	}
}
\item{pmcorrect.method}{
	Character vector. It contains the name of the PM correction method, which is enabled
	only when numerical values are available for the MM probes of the input
	\code{AffyBatch} object. Running \code{NormiR.pmcorrect.methods(abatch)} indicates
	which other methods can be chosen instead of the default one \code{pmonly}.
}
\item{pmcorrect.param}{
	A \code{R} list of optional parameters for the selected \code{pmcorrect.method}, as specified
	in the documentation of the original function \code{pmcorrect} function of the \code{affy} package.
}
\item{summary.method}{
	Character vector. It contains the name of the summarization method. Running
        \code{NormiR.summary.methods()} indicates which other methods can be chosen instead
	of the default one \code{medianpolish}.
}
\item{summary.param}{
	A \code{R} list of optional parameters for the selected \code{summary.method}, as specified
	in the documentation of the original \code{AffyBatch} method \code{computeExprSet} contained in
	the \code{affy} package.
}
\item{summary.subset}{
	A \code{R} list of probe set identifiers. When set to its default \code{NULL} value, the
	summarized expression values are computed for all probe sets available on the array.
}
\item{verbose}{
	Logical. The default value is \code{TRUE}. The details of the function execution are displayed on the console.
}
\item{...}{
	Any additional argument. Used for backward compatibility.
}
}

\details{
See accompanying vignette.  
}

\value{
An \code{ExpressionSet} object containing the normalized expression data.
}

\examples{
data(galenv)
data(GSE20122)
eset.spike <- NormiR(GSE20122,
                     bg.correct=FALSE,
                     normalize.method='spikein',
                     summary.method='medianpolish')
}

\author{
Sylvain Gubian, Alain Sewer, PMP SA
}


\seealso{
\code{bg.correct.miR},
\code{NormiR.bgcorrect.methods},
\code{norm.miR},
\code{NormiR.normalize.methods},
\code{NormiR.spikein.args},
\code{NormiR.pmcorrect.methods},
\code{summarize.miR},
\code{NormiR.summary.methods}.
}

\name{bg.correct.miR}
\alias{bg.correct.miR}

\title{
ExiMiR low-level function for background correction
}
\description{
This function performs background correction on an \code{AffyBatch} object.

The methods supported by \code{bg.correct.miR} are provided by the \code{affy}
or \code{limma} packages, depending on whether the input \code{AffyBatch} object
has been created with \code{ReadAffy} or \code{ReadExi}/\code{createAB}, respectively.

}

\usage{
bg.correct.miR(abatch,
	       bgcorrect.method='auto',
	       bgcorrect.param=list(),
	       verbose=FALSE)
}

\arguments{
\item{abatch}{
	An \code{AffyBatch} object.
}
\item{bgcorrect.method}{
	Character vector. It contains the name of the background correction method. Running
	\code{NormiR.bgcorrect.methods(abatch)} indicates which methods can be used, depending
        on the raw data contained in the \code{abatch} object. The \code{auto} option
	corresponds to the default choice of applying \code{rma} for single-channel arrays
	and \code{normexp} for dual-channel arrays.
}
\item{bgcorrect.param}{
	A \code{R} list containing the parameters required by the selected background correction method,
	as specified in the documentation of the original functions \code{bg.correct} of the
	\code{affy} package or \code{backgroundCorrect} of the \code{limma} package. As an illustration
	the parameters of the \code{normexp} method of the \code{limma} package are given below.
	\describe{
	\item{normexp.method}{
		Character vector. The variant of the \code{normexp} method, matching exactly
		the argument \code{normexp.method} of the \code{backgroundCorrect} function. 
	}
	\item{offset}{
		Numeric value to add to intensities. It matches exactly the argument
 		\code{offset} of the \code{backgroundCorrect} function. 
	}
	}
}
\item{verbose}{
	Logical. The default value is \code{TRUE}. The details of the function execution are displayed on the console.
}
}

\details{
See accompanying vignette.  
}

\value{
An \code{AffyBatch} object containing the background-corrected raw expression data.
}

\examples{
data(galenv)
data(GSE20122)
NormiR.bgcorrect.methods(GSE20122)
GSE20122.bgcorrected <- bg.correct.miR(GSE20122,
                                       bgcorrect.method='normexp',
                                       bgcorrect.param=list(offset=50))
}

\author{
Sylvain.Gubian, Alain Sewer, PMP SA
}

\seealso{
\code{NormiR.bgcorrect.methods},
\code{NormiR}.
}

\name{NormiR.methods}
\alias{NormiR.bgcorrect.methods}
\alias{NormiR.normalize.methods}
\alias{NormiR.pmcorrect.methods}
\alias{NormiR.summary.methods}
\alias{NormiR.spikein.args}

\title{
ExiMiR functions for enumerating the names of low-level normalization methods or arguments 
}

\description{
These functions enumerate the names of methods or arguments of the low-level functions for
miRNA raw data normalization (i.e. background correction, (spike-in probe-based) normalization,
PM corrrection, summarization). They take into account how the input \code{AffyBatch} object
was created as well as the underlying array type.
}

\usage{
NormiR.bgcorrect.methods(object)
NormiR.normalize.methods(object)
NormiR.pmcorrect.methods(object)
NormiR.summary.methods()
NormiR.spikein.args()
}

\arguments{
\item{object}{
An \code{AffyBatch} object.
}
}

\value{
List of strings containing the names of the methods or arguments available for the input \code{AffyBatch} object.
}

\details{
See accompanying vignette.  
}

\author{
Sylvain.Gubian, Alain.Sewer, PMP SA
}

\seealso{
\code{NormiR},
\code{bg.correct.miR},
\code{norm.miR},
\code{summarize.miR}.
}

\name{GSE20122}
\alias{GSE20122}

\title{
Affybatch object for the raw data from GEO series GSE20122
}
\description{
The Affybatch object \code{GSE20122} contains the raw expression data contained in the ImaGene TXT
files of the GEO series GSE20122, obtained from the Exiqon miRCURY LNA platform v.11.
}
\details{
See accompanying vignette.  
}

\name{galenv}
\alias{galenv}

\title{
R annotation environment for GEO series GSE20122
}
\description{
The \code{galenv} environment is a hash table for the annotation of the Exiqon miRCURY
LNA arrays used in the GEO series GSE20122 (Exiqon miRCURY LNA array v.11).
}

\details{
See accompanying vignette.  
}

\seealso{
\code{make.gal.env}.
}

\name{GSE19183}
\alias{GSE19183}

\title{
Affybatch object for the raw data from GEO series GSE19183
}
\description{
The Affybatch object \code{GSE19183} contains the raw expression data contained in the CEL files
of the GEO series GSE19183, obtained from the Affymetrix miRNA-1_0 platform. The annotation is
included in the Affybatch object. 
}
\details{
See accompanying vignette.  
}

\name{make.gal.env}
\alias{make.gal.env}

\title{
GAL Environment Maker
}
\description{
Reads an Exiqon GAL file and creates an annotation environment used as a hash table for the probeset mapping location.
}
\usage{
make.gal.env(galname=NULL,
             filename=NULL,
             gal.path=getwd(),
             verbose=FALSE)
}

\arguments{
\item{galname}{
	Character vector. Name to be used for the annotation environment.
}
\item{filename}{
	Character vector. Name of the GAL file.
}
\item{gal.path}{
	Character vector. Path to the GAL file.
}
\item{verbose}{
	Logical. The default value is \code{TRUE}. The details of the function execution are displayed on the console.
}
}

\details{
This function is designed similarly to \code{make.cdf.env} from the \code{makecdfenv} package.
If no filename is provided as argument, the function tries to read the first GAL file in the input path.
The returned environment is a hash table. For every probeset name we have a matrix with 2 columns. The
first column contains the PM locations and the second column the MM locations. For PM only chips the MM column
will have NAs.
}

\value{
None.
}

\examples{
# The folder 'Exiqon' contains a GAL file
\dontrun{make.gal.env(galname='galenv', gal.path='Exiqon')}
}

\author{
Sylvain Gubian, Alain Sewer, PMP SA
}

\name{createAB}
\alias{createAB}

\title{
ExiMiR function for creating an AffyBatch object from other object types (RGList, EListRaw, MAList or list)
}

\description{
This function creates an \code{AffyBatch} object from a \code{limma} object (\code{RGList}, \code{EListRaw}, \code{MAList}) or from any appropriate \code{list} object.
}
\usage{
createAB(object,
         verbose=TRUE,
         ref.channel="R",
         genes.block=NULL,
         genes.row=NULL,
         genes.col=NULL,
         genes.id=NULL,
         genes.name=NULL,
         galname=NULL,
         env.overwrite=TRUE,
         ...)
}

\arguments{
\item{object}{
	An appropriate \code{EListRaw}, \code{RGList}, \code{MAList} or \code{list} object.
}
\item{verbose}{
	Logical. The default value is \code{TRUE}. The details of the function execution are displayed on the console.
}
\item{genes.block}{
	Optional character vector in case the platform is neither ImaGene, Exiqon nor Agilent. The name of the column
	in the \code{object$genes} data frame that contains the block or field values.
}
\item{genes.row}{
	Optional character vector in case the platform is neither ImaGene, Exiqon nor Agilent. The name of the column
	in the \code{object$genes} data frame that contains the row values.
}
\item{genes.col}{
	Optional character vector in case the platform is neither ImaGene, Exiqon nor Agilent. The name of the column
in the \code{object$genes} data frame that contains the column values.
}
\item{genes.id}{
	Optional character vector in case the platform is neither ImaGene, Exiqon nor Agilent. The name of the column
in the \code{object$genes} data frame that contains the gene IDs.
}
\item{genes.name}{
	Optional character vector in case the platform is neither ImaGene, Exiqon nor Agilent. The name of the column
	in the \code{object$genes} data frame that contains gene names.
}
\item{ref.channel}{
	Character vector. The value of the reference channel for two-color arrays ('R' or 'G') 
}
\item{galname}{
	Character vector. The default value is \code{NULL}. In this case the GAL annotation
	environment used by \code{createAB} for generating the resulting \code{AffyBatch}
	object is lost. Assigning \code{galname} a non-empty value allows to control this GAL
	environment, which is useful in two specific situations. First, it gives a handle to this
	GAL annotation environment for later use. Second, if an adequate GAL annotation environment already
	exists in the memory (e.g. after having been generated by \code{createAB} or by
	\code{make.gal.env}), \code{galname} allows to force \code{createAB} to use it for
	generating the resulting \code{AffyBatch} object.
}
\item{env.overwrite}{
	Logical. The default value is \code{TRUE}. If a GAL annotation environment with the
	same name already exists in the memory, it will be overwritten. This may be useful
	when the piece of code containing \code{createAB} is run several times.
}
\item{...}{
	Any additional argument that can be given to the \code{AffyBatch} constructor, as specified
	in the documentation of the \code{AffyBatch} object provided in the \code{affy} package.
}
}

\details{
See accompanying vignette.
}

\value{
An \code{AffyBatch} object containing the raw expression data.
}

\author{
Sylvain Gubian, Alain Sewer, PMP SA
}


\seealso{
\code{ReadExi},
\code{make.gal.env}.
}

\name{summarize.miR}
\alias{summarize.miR}

\title{
ExiMiR low-level function for summarization.
}

\description{
This function performs summarization on an \code{AffyBatch} object using a
GAL or CDF annotation environment and generates an \code{ExpressionSet} object
containing the results.
}

\usage{
summarize.miR(abatch,
	      pmcorrect.method='pmonly',
	      pmcorrect.param=list(),
	      summary.method='medianpolish',
	      summary.param=list(),
	      summary.subset=NULL)
}

\arguments{
\item{abatch}{
	An \code{AffyBatch} object.
}
\item{pmcorrect.method}{
	Character vector. It contains the name of the PM correction method, which is enabled
	only when numerical values are available for the MM probes of the input
	\code{AffyBatch} object. Running \code{NormiR.pmcorrect.methods(abatch)} indicates
	which other methods can be chosen instead of the default one \code{pmonly}.
}
\item{pmcorrect.param}{
	A \code{R} list of optional parameters for the selected \code{pmcorrect.method}, as specified
	in the documentation of the original function \code{pmcorrect} function of the \code{affy} package.
}
\item{summary.method}{
	Character vector. It contains the name of the summarization method. Running
        \code{NormiR.summary.methods()} indicates which other methods can be chosen instead
	of the default one \code{medianpolish}.
}
\item{summary.param}{
	A \code{R} list of optional parameters for the selected \code{summary.method}, as specified
	in the documentation of the original \code{AffyBatch} method \code{computeExprSet} contained in
	the \code{affy} package.
}
\item{summary.subset}{
	A \code{R} list of probe set identifiers. When left to its default \code{NULL} value, the
	summarized expression values are computed for all probe sets available on the array.
}	
}

\value{
An \code{ExpressionSet} containing the summarized expression data.
}

\examples{
data(galenv)
data(GSE20122)
eset <- summarize.miR(GSE20122,
                      summary.method="medianpolish")
}

\author{
Sylvain.Gubian, Alain Sewer, PMP SA
}

\seealso{
\code{NormiR.pmcorrect.methods},
\code{NormiR.summary.methods},
\code{NormiR}.
}

\name{ReadExi}
\alias{ReadExi}

\title{
ExiMiR function for reading Exiqon raw data into an AffyBatch object.
}

\description{
This function reads Exiqon raw data in ImaGene file format and creates an \code{AffyBatch}
object.
}

\usage{
ReadExi(txtfile.path=getwd(),
        galname=NULL,
        description=NULL,
	notes='',
	rm.background=FALSE,
	verbose=TRUE)
}

\arguments{
\item{txtfile.path}{
	Character vector. It contains the path to the folder containing the
	\code{samplesinfo.txt} file and the Exiqon raw data files in ImaGene \code{txt} format.
}
\item{galname}{
	Character vector. The default value is \code{NULL}. In this case the GAL annotation
	environment used by \code{ReadExi} for generating the resulting \code{AffyBatch}
	object is lost. Assigning \code{galname} a non-empty value allows to control this GAL
	environment, which is useful in two specific situations. First, it gives a handle to this
	GAL annotation environment for later use. Second, if an adequate GAL annotation
	environment already exists in the memory (e.g. after having been generated by
	\code{ReadExi} or by \code{make.gal.env}), \code{galname} allows to force
	\code{ReadExi} to use it for generating the resulting \code{AffyBatch} object.
}
\item{description}{
	Object of class MIAME, as specified in the documentation of the \code{AffyBatch}
	object provided in the \code{affy} package.
}
\item{notes}{
	Character vector, as specified in the documentation of the \code{AffyBatch} object
	provided in the \code{affy} package.
}
\item{rm.background}{
	Logical. This option is kept for compatibility reasons but it is not used anymore. See
	the \code{NormiR} options for background correction.
}
\item{verbose}{
	Logical. The default value is \code{TRUE}. The details of the function execution are displayed on the console.
}
}

\details{
The Exiqon miRNA raw expression data are normally in ImageGene \code{txt} file format and
accompanied by a \code{samplesinfo.txt} description file. It enumerates the names of the
sample files for each channel. Therefore the \code{txtfile.path} argument of \code{ReadExi}
must be a folder that contains the ImageGene and the \code{samplesinfo.txt} files. If this
is not the case, \code{ReadExi} stops.

The \code{galname} argument of \code{ReadExi} must be the name of a GAL annotation
environment created with the \code{make.gal.env} or the \code{ReadExi} functions. If \code{galname}
is provided a \code{NULL} value, which is the default situation, a minimal GAL annotation
environment is created based on the annotation contained in the ImageGene \code{txt} files.
}

\value{
An \code{AffyBatch} object containing the raw expression data.
}

\examples{
# The folder 'Exiqon' contains the file 'samplesinfo.txt' and  the corresponding raw data files in ImaGene format
\dontrun{ebatch <- ReadExi(txtfile.path='Exiqon')}
# If the GAL environment has already created by the function make.gal.env
\dontrun{ebatch <- ReadExi(galenv='galenv', txtfile.path='Exiqon')}
}


\author{
Sylvain Gubian, Alain Sewer, PMP SA
}

\section{Warning}{
The \code{image} method of the \code{AffyBatch} object might not work properly when the
\code{galname} argument of \code{ReadExi} has not been assigned.
}

\seealso{
\code{make.gal.env},
\code{createAB}.
}

\name{ExiMiR-package}
\alias{ExiMiR}
\docType{package}

\title{
R functions for the normalization of Exiqon miRNA array data
}

\description{
This package contains functions for reading raw data in ImaGene TXT format obtained from Exiqon miRCURY LNA arrays, annotating them with appropriate GAL files, and normalizing them using a spike-in probe-based method. Other platforms and data formats are also supported by ExiMiR.
}
\details{
\tabular{ll}{
Package: \tab ExiMiR\cr
Type: \tab Package\cr
Version: \tab 1.99.0\cr
Date: \tab 2012-04-24\cr
License: \tab GPL-2\cr
LazyLoad: \tab yes\cr
}
}
\author{
Sylvain Gubian, Alain Sewer, PMP SA\cr
Maintainer: DL.RSupport@pmi.com
}
